//+------------------------------------------------------------------+
//|                                        PHIL's MACD All Pairs.mq4 |
//|                         Initial coding ALL Stochastics by mladen |
//|                                                 made by : Yannis |
//+------------------------------------------------------------------+
#property copyright   "this is public domain software"
#property link        "www.forex-tsd.com"
#define indicatorName "MACD ALL PAIRS"

//
// 
//
//
//

#property indicator_separate_window

#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_style1  STYLE_SOLID

#property indicator_color3  Crimson
#property indicator_style3  STYLE_SOLID

#property indicator_color2  SpringGreen
#property indicator_style2  STYLE_SOLID

#property indicator_levelcolor DimGray
#property  indicator_level1  69	
#property  indicator_level2  46	
#property  indicator_level3  23	
#property  indicator_level4  -23	
#property  indicator_level5  -46	
#property  indicator_level6  -69	
#property  indicator_level7  0

//---- input parameters
//
//
//
//
//

extern int    FastEma              = 5;
extern int    SlowEma              = 13;
extern int    SignalSma            = 1;
extern int    MAMethod             = 0;
extern int    PriceField           = 0;
extern string __                   = "Chose timeframes (as in periodicity bar)";
extern string timeFrames           = "H4";
extern int    barsPerTimeFrame     = 10;
extern color  txtColor             = LightCyan; 
extern color  separatorColor       = DimGray; 

bool   shiftRight           = False;
bool   currentFirst         = True; 

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
int minlevel[]={5,10,15,-5,-10,-15};
int hourlevel[]={45,30,15,-15,-30,-45};
int daylevel[]={90,60,30,-30,-60,-90};

string shortName;
string labels[];
int    periods[];
int    Shift; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
      if (shiftRight) Shift = 1;
      else            Shift = 0;
            barsPerTimeFrame = MathMax(barsPerTimeFrame,10);      
            shortName = indicatorName+" ("+FastEma+","+SlowEma+","+SignalSma+")";
                        IndicatorShortName(shortName);

         SetIndexBuffer(0,ExtMapBuffer1);
         SetIndexBuffer(1,ExtMapBuffer2);
         SetIndexBuffer(2,ExtMapBuffer3);

         SetIndexStyle(0,DRAW_HISTOGRAM,0,2);
         SetIndexStyle(1,DRAW_LINE,0,2);
         SetIndexStyle(2,DRAW_HISTOGRAM,0,2);


         SetIndexShift(0,Shift*(barsPerTimeFrame+1));
         SetIndexShift(1,Shift*(barsPerTimeFrame+1));
         SetIndexShift(2,Shift*(barsPerTimeFrame+1));

         SetIndexLabel(0,"MACD Green");
         SetIndexLabel(1,"Signal");      
         SetIndexLabel(2,"MACD Red");

      timeFrames = StringUpperCase(StringTrimLeft(StringTrimRight(timeFrames)));
      if (StringSubstr(timeFrames,StringLen(timeFrames),1) != ";")
                       timeFrames = StringConcatenate(timeFrames,";");

           
         int s = 0;
         int i = StringFind(timeFrames,";",s);
         int time;
         string current;

         while (i > 0)
         {
            current = StringSubstr(timeFrames,s,i-s);
            time    = stringToTimeFrame(current);
            if (time > 0) 
            {  ArrayResize(labels ,ArraySize(labels)+1);
               ArrayResize(periods,ArraySize(periods)+1);
               labels[ArraySize(labels)-1] = current; 
               periods[ArraySize(periods)-1] = time; 
            }
            s = i + 1;
            i = StringFind(timeFrames,";",s);
         }
      
      if(currentFirst)
         for (i=1;i<ArraySize(periods);i++)
         if (Period()==periods[i])
         {  string tmpLbl = labels[i];
            int    tmpPer = periods[i];
               
            for (int k=i ;k>0; k--) 
            {  labels[k]  = labels[k-1];
               periods[k] = periods[k-1];
            }                     
            labels[0]  = tmpLbl;
            periods[0] = tmpPer;
         }



   /*
   This is the base multiplier.  Calculated from Phillip Nel's original 15/30/45 levels
   for EURUSD.  So, if 15 is our low level for a typical EURUSD value of 1.3, we say
     1.3 * baseMult = 15, and we get baseMult ~= 11.5.  Good enough!  Doesn't have to be really exact.
   */

   double lastPrice = iClose(NULL,0,1);
   if (StringFind(Symbol(), "JPY", 0) != -1)
   {
      lastPrice = lastPrice / 100;
   }

   double baseHourMult = 11.5;
   double baseDayMult = baseHourMult*2;
   double baseMinMult = baseHourMult/3;

   double lowMinLevel = baseMinMult*lastPrice;
   double lowHourLevel = baseHourMult*lastPrice;
   double lowDayLevel = baseDayMult*lastPrice;

   ArrayInitialize(minlevel,0);
   minlevel[0] = lowMinLevel*3;
   minlevel[1] = lowMinLevel*2;
   minlevel[2] = lowMinLevel;
   minlevel[3] = -lowMinLevel;
   minlevel[4] = -lowMinLevel*2;
   minlevel[5] = -lowMinLevel*3;

   ArrayInitialize(hourlevel,0);
   hourlevel[0] = lowHourLevel*3;
   hourlevel[1] = lowHourLevel*2;
   hourlevel[2] = lowHourLevel;
   hourlevel[3] = -lowHourLevel;
   hourlevel[4] = -lowHourLevel*2;
   hourlevel[5] = -lowHourLevel*3;
   
   ArrayInitialize(daylevel,0);
   daylevel[0] = lowDayLevel*3;
   daylevel[1] = lowDayLevel*2;
   daylevel[2] = lowDayLevel;
   daylevel[3] = -lowDayLevel;
   daylevel[4] = -lowDayLevel*2;
   daylevel[5] = -lowDayLevel*3;


	switch(Period())
	{
		case PERIOD_M1:
		case PERIOD_M5:
		case PERIOD_M15:
		case PERIOD_M30:
			for(int x=0;x<ArraySize(minlevel);x++)
			   SetLevelValue(x,minlevel[x]);
			break;
		case PERIOD_H1:
		case PERIOD_H4:
			for(x=0;x<ArraySize(hourlevel);x++)
			   SetLevelValue(x,hourlevel[x]);
			break;
		default:
			for(x=0;x<ArraySize(daylevel);x++)
			   SetLevelValue(x,daylevel[x]);
	}



   return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   for(int l=0;l<ArraySize(periods);l++) {
         ObjectDelete(indicatorName+l);
         ObjectDelete(indicatorName+l+"label");
      }         
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
     string separator;
     int    window=WindowFind(shortName);
     int    k=0,p=0;

      //----------------------------------------------------------------------------------------------------------------------------------------------
      // GBPUSD
      //----------------------------------------------------------------------------------------------------------------------------------------------
      k += 1;
      for (int i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("GBPUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("GBPUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("GBPUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         
         if (iMACD("GBPUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("GBPUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("GBPUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("GBPUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" GBPUSD";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" GBPUSD "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"GBPUSD",9,"Tahoma",txtColor);


      k += 1;



      //----------------------------------------------------------------------------------------------------------------------------------------------
      // EURUSD
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("EURUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("EURUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("EURUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("EURUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("EURUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("EURUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("EURUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" EURUSD";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" EURUSD "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"EURUSD",9,"Tahoma",txtColor);
      k += 1;


      //----------------------------------------------------------------------------------------------------------------------------------------------
      // USDCHF
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("USDCHF",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("USDCHF",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("USDCHF",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("USDCHF",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("USDCHF",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("USDCHF",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("USDCHF",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" USDCHF";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" USDCHF "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"USDCHF",9,"Tahoma",txtColor);

      k += 1;

      //----------------------------------------------------------------------------------------------------------------------------------------------
      // USDJPY
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("USDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("USDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point/100,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("USDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("USDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("USDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("USDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("USDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" USDJPY";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" USDJPY "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"USDJPY",9,"Tahoma",txtColor);
      k += 1;

      //----------------------------------------------------------------------------------------------------------------------------------------------
      // GBPJPY
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("GBPJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("GBPJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point/100,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("GBPJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("GBPJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("GBPJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("GBPJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("GBPJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" GBPJPY";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" GBPJPY "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"GBPJPY",9,"Tahoma",txtColor);
      k += 1;


      //----------------------------------------------------------------------------------------------------------------------------------------------
      // EURJPY
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("EURJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("EURJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point/100,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("EURJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("EURJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("EURJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("EURJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("EURJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" EURJPY";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" EURJPY "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"EURJPY",9,"Tahoma",txtColor);


      k += 1;

      //----------------------------------------------------------------------------------------------------------------------------------------------
      // USDCAD
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("USDCAD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("USDCAD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("USDCAD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("USDCAD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("USDCAD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("USDCAD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("USDCAD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" USDCAD";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" USDCAD "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"USDCAD",9,"Tahoma",txtColor);
      k += 1;

      //----------------------------------------------------------------------------------------------------------------------------------------------
      // AUDUSD
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("AUDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("AUDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("AUDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("AUDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("AUDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("AUDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("AUDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" AUDUSD";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" AUDUSD "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"AUDUSD",9,"Tahoma",txtColor);

      k += 1;

      //----------------------------------------------------------------------------------------------------------------------------------------------
      // NZDUSD
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("NZDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("NZDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("NZDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("NZDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("NZDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("NZDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("NZDUSD",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" NZDUSD";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" NZDUSD "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"NZDUSD",9,"Tahoma",txtColor);

      k += 1;

      //----------------------------------------------------------------------------------------------------------------------------------------------
      // NZDJPY
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("NZDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("NZDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point/100,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("NZDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("NZDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("NZDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("NZDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("NZDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" NZDJPY";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" NZDJPY "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"NZDJPY",9,"Tahoma",txtColor);


      k += 1;

      //----------------------------------------------------------------------------------------------------------------------------------------------
      // CHFJPY
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("CHFJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("CHFJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point/100,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("CHFJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("CHFJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("CHFJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("CHFJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("CHFJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" CHFJPY";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" CHFJPY "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"CHFJPY",9,"Tahoma",txtColor);

      k += 1;


      //----------------------------------------------------------------------------------------------------------------------------------------------
      // AUDJPY
      //----------------------------------------------------------------------------------------------------------------------------------------------
      for (i=0; i<barsPerTimeFrame;i++,k++)
      {  ExtMapBuffer1[k] = NormalizeDouble(iMACD("AUDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         ExtMapBuffer2[k] = NormalizeDouble(iMACD("AUDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_SIGNAL,i)/Point/100,1);
         ExtMapBuffer3[k] = NormalizeDouble(iMACD("AUDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         
         //Print ("1. ",NormalizeDouble(ExtMapBuffer1[k],4));
         
         
         if (iMACD("AUDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)>iMACD("AUDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i+1))
         {  ExtMapBuffer3[k]=EMPTY_VALUE;
            ExtMapBuffer1[k] = NormalizeDouble(iMACD("AUDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
         else
         {  ExtMapBuffer1[k]=EMPTY_VALUE;
            ExtMapBuffer3[k] = NormalizeDouble(iMACD("AUDJPY",timeFrames,FastEma,SlowEma,SignalSma,PRICE_CLOSE,MODE_MAIN  ,i)/Point/100,1);
         }         
      }
      ExtMapBuffer1[k] =EMPTY_VALUE;
      ExtMapBuffer2[k] =EMPTY_VALUE;
      ExtMapBuffer3[k] =EMPTY_VALUE;
      k += 1;
      
      separator = indicatorName+" AUDJPY";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TREND,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
         ObjectSet(separator,OBJPROP_PRICE1,-100);
         ObjectSet(separator,OBJPROP_PRICE2,100);
         ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
         ObjectSet(separator,OBJPROP_WIDTH ,5);
      
      separator = indicatorName+" AUDJPY "+"label";
      if (ObjectFind(separator)==-1)
         ObjectCreate(separator,OBJ_TEXT,window,0,0);
         ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
         ObjectSet(separator,OBJPROP_PRICE1,0);            
         ObjectSetText(separator,"AUDJPY",9,"Tahoma",txtColor);

      k += 1;



      SetIndexDrawBegin(0,Bars-k);
      SetIndexDrawBegin(1,Bars-k);              
      SetIndexDrawBegin(2,Bars-k);              
   
   return(0);
}

//+------------------------------------------------------------------+
//+ Custom functions and procedures                                  +
//+------------------------------------------------------------------+

int barTime(int a)
{
   if(a<0)
         return(Time[0]+Period()*60*MathAbs(a));
   else  return(Time[a]);   
}

//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string TimeFrame)
{
   int TimeFrameInt=0;
      if (TimeFrame=="M1")  TimeFrameInt=PERIOD_M1;
      if (TimeFrame=="M5")  TimeFrameInt=PERIOD_M5;
      if (TimeFrame=="M15") TimeFrameInt=PERIOD_M15;
      if (TimeFrame=="M30") TimeFrameInt=PERIOD_M30;
      if (TimeFrame=="H1")  TimeFrameInt=PERIOD_H1;
      if (TimeFrame=="H4")  TimeFrameInt=PERIOD_H4;
      if (TimeFrame=="D1")  TimeFrameInt=PERIOD_D1;
      if (TimeFrame=="W1")  TimeFrameInt=PERIOD_W1;
      if (TimeFrame=="MN")  TimeFrameInt=PERIOD_MN1;
   return(TimeFrameInt);
}


string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
          else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
                  
                                
         lenght--;
   }
   
   return(s);
}