//+------------------------------------------------------------------+
//|                                                 MACD ESSAI 2.mq4 |
//+------------------------------------------------------------------+
//|                                                                  |
 
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Red // DodgerBlue
#property indicator_color2  Lime
#property indicator_color3  LightSalmon //DodgerBlue
#property indicator_color4  White

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 1


//---- indicator parameters
extern int        longue  =  134;
extern int Smooth_long    =  300;
extern int        courte  =   17;
extern int Smooth_court   =    8;
extern int Smooth_result  =   17;
extern int size           =    5;
extern double   x_trig = 12;

//---- indicator buffers
double   ligne[];
double   ligne_smoothed[];
double   Osma[];
double   trigger[];

double   long[];
double   long_smoothed[];
double   court[];
double   court_smoothed[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(8);
//---- drawing settings
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   
//---- 5 indicator buffers mapping
    SetIndexBuffer(0,Osma) ;      
    SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID, 2);
 
    SetIndexBuffer(1,trigger) ;
    SetIndexStyle(1,DRAW_LINE);
 
    SetIndexBuffer(2,ligne ) ;
    SetIndexStyle(2,DRAW_LINE);
 
    SetIndexBuffer(3,ligne_smoothed) ;
    SetIndexStyle(3,DRAW_LINE);
 
     SetIndexBuffer(4,long );
     SetIndexStyle(4,DRAW_NONE);
    SetIndexBuffer(5,long_smoothed );
    SetIndexStyle(5,DRAW_NONE);
    SetIndexBuffer(6,court ) ;
    SetIndexStyle(6,DRAW_NONE);
    SetIndexBuffer(7,court_smoothed ) ;
    SetIndexStyle(7,DRAW_NONE);

 
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD ESSAI");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
      long[i]  =   iMA(NULL,0,longue,0,MODE_EMA,PRICE_CLOSE,i); 
   for( i=0; i<limit; i++)
      long_smoothed[i]=iMAOnArray(long,Bars,Smooth_long,0,MODE_EMA,i);
//---- main loop
   for(i=0; i<limit; i++)
     court[i]=  iMA(NULL,0,courte,0,MODE_EMA,PRICE_CLOSE,i); 
   for(i=0; i<limit; i++)
      court_smoothed[i]=iMAOnArray( court, Bars,Smooth_court,0,MODE_EMA,i);
//--------------- 
  for(i=0; i<limit; i++)
      ligne[i] =  court_smoothed[i]- long_smoothed[i] ;
  for(i=0; i<limit; i++)
       ligne_smoothed[i]=iMAOnArray( ligne, Bars,Smooth_result,0,MODE_EMA,i);
 for(i=0; i<limit; i++)
    Osma[i] = size*(ligne[i] - ligne_smoothed[i]);
 
 
 
     for(i=0; i<limit; i++)
      {
      if( Osma[i] > 0  ) trigger[i] =  x_trig * 0.00025;
      if( Osma[i] < 0  ) trigger[i] = -x_trig * 0.00025;
     }
 
//---- done
   return(0);
  }
//+------------------------------------------------------------------+
//-------------------------------------------------------------+