//+----------------------------------------------------------------------------+
//| MACD LWMA v1.01.mq4
//| Copyright  23 maggio 2011, gspe
//| gspe@ae-design.ws
//| 
//|
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
// Based on
//+------------------------------------------------------------------+
//|                                                         MACD.mq4 |
//|                                Copyright  2005, David W. Thomas |
//|                                           mailto:davidwt@usa.net |
//+------------------------------------------------------------------+
// This is the correct computation and display of MACD.
#property copyright "Copyright  2011, gspe"
#property link      "mailto:gspe@ae-design.ws"
#property copyright "Copyright  2005, David W. Thomas"
#property link      "mailto:davidwt@usa.net"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 DodgerBlue
#property indicator_color4 Tomato
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3

//---- input parameters
extern int       FastMAPeriod=12;
extern int       SlowMAPeriod=26;
extern int       SignalMAPeriod=9;

//---- buffers
double MACDLineBuffer[];
double SignalLineBuffer[];
double HistogramBufferUp[];
double HistogramBufferDn[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
	//---- indicators
	SetIndexStyle(0,DRAW_LINE, STYLE_SOLID);
	SetIndexBuffer(0,MACDLineBuffer);
	SetIndexDrawBegin(0,SlowMAPeriod);
	SetIndexStyle(1,DRAW_LINE, STYLE_DOT);
	SetIndexBuffer(1,SignalLineBuffer);
	SetIndexDrawBegin(1,SlowMAPeriod+SignalMAPeriod);
	SetIndexStyle(2,DRAW_HISTOGRAM);
	SetIndexBuffer(2,HistogramBufferUp);
	SetIndexDrawBegin(2,SlowMAPeriod+SignalMAPeriod);
	SetIndexStyle(3,DRAW_HISTOGRAM);
	SetIndexBuffer(3,HistogramBufferDn);
	SetIndexDrawBegin(3,SlowMAPeriod+SignalMAPeriod);
	//---- name for DataWindow and indicator subwindow label
	IndicatorShortName("MACD LWMA("+FastMAPeriod+","+SlowMAPeriod+","+SignalMAPeriod+")");
	SetIndexLabel(0,"MACD");
	SetIndexLabel(1,"Signal");
	//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   //---- 
   
   //----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	int i, limit;
	double value=0;
	
	int counted_bars = IndicatorCounted();
	//---- check for possible errors
	if (counted_bars<0) return(-1);
	//---- last counted bar will be recounted
	if (counted_bars>0) counted_bars--;
	limit = Bars - counted_bars;
	
	for(i=limit; i>=0; i--)
	{
		MACDLineBuffer[i] = iMA(NULL,0,FastMAPeriod,0,MODE_LWMA,PRICE_CLOSE,i) - iMA(NULL,0,SlowMAPeriod,0,MODE_LWMA,PRICE_CLOSE,i);
	}
	for(i=limit; i>=0; i--)
	{
		SignalLineBuffer[i] = iMAOnArray(MACDLineBuffer,Bars,SignalMAPeriod,0,MODE_LWMA,i);
	}
	for(i=limit; i>=0; i--)
	{
		HistogramBufferUp[i] = 0;
		HistogramBufferDn[i] = 0;
		value = MACDLineBuffer[i] - SignalLineBuffer[i];
		if(value > 0){HistogramBufferUp[i] = value;}
		if(value < 0){HistogramBufferDn[i] = value;}
	}
	
	//----
	return(0);
}
//+------------------------------------------------------------------+