//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 8
#property  indicator_color1  Black
#property  indicator_color2  MintCream
#property  indicator_color3  Red
#property  indicator_color4  Aqua
#property  indicator_color5  Blue
#property  indicator_color6  Yellow
#property  indicator_color7  Red
#property  indicator_color8  Aqua
//---- indicator parameters
extern string Master_pair="EURUSD";
extern string Slave_pair="GBPUSD";
extern int Pogreshnost = 5;
extern int FastEMA=12;
extern int SlowEMA=26;
extern bool UseM1 = False;
extern bool UseM5 = True;
extern bool UseM15 = True;
extern bool UseM30 = True;
extern bool UseH1 = True;
extern bool UseH4 = True;
extern bool UseD1 = False;
//---- indicator buffers
double     Buffer1[], Buffer5[], Buffer15[], Buffer30[], BufferH1[], BufferH4[], BufferD1[], BufferSig[];
double     SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorDigits(Digits+1);
   IndicatorShortName("MACD_pair("+FastEMA+","+SlowEMA+"), "+Master_pair+"-"+Slave_pair+"");
//---- indicator buffers mapping
   SetIndexBuffer(0,Buffer1);
   SetIndexStyle (0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexLabel(0,"1");

   SetIndexBuffer(1,Buffer5);
   SetIndexStyle (1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexLabel(1,"5");

   SetIndexBuffer(2,Buffer15);
   SetIndexStyle (2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexLabel(2,"15");

   SetIndexBuffer(3,Buffer30);
   SetIndexStyle (3,DRAW_LINE,STYLE_SOLID,1);
   SetIndexLabel(3,"30");

   SetIndexBuffer(4,BufferH1);
   SetIndexStyle (4,DRAW_LINE,STYLE_SOLID,1);
   SetIndexLabel(4,"H1");

   SetIndexBuffer(5,BufferH4);
   SetIndexStyle (5,DRAW_LINE,STYLE_SOLID,1);
   SetIndexLabel(5,"H4");

   SetIndexBuffer(6,BufferD1);
   SetIndexStyle (6,DRAW_LINE,STYLE_SOLID,1);
   SetIndexLabel(6,"D1");

   SetIndexBuffer(7,BufferSig);
   SetIndexStyle (7,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(7,252);
   SetIndexLabel(7,"SIGNAL");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit, s1, s2, s3, s4, s5, s6, s7;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=iBars(NULL, PERIOD_M5) - counted_bars;
//---- macd counted in the 1-st buffer
   for(int ii=0; ii<limit; ii++)
    {
      int i = iBarShift( NULL, Period(), iTime(NULL, PERIOD_M5, ii), FALSE);
      Buffer1[i]=0;
      int j = iBarShift( NULL, PERIOD_M1, iTime(NULL, PERIOD_M5, ii), FALSE);
      s1 = 1;
      if(PERIOD_M1<=PERIOD_M1 && UseM1)
      {
      Buffer1[i]=(iMA(Master_pair,PERIOD_M1,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Master_pair,PERIOD_M1,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j))-
      (iMA(Slave_pair,0,FastEMA,PERIOD_M1,MODE_EMA,PRICE_CLOSE,j)-iMA(Slave_pair,PERIOD_M1,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j));
      if(Buffer1[i]>Pogreshnost*Point || Buffer1[i]<-Pogreshnost*Point) s1 = 0;
      }
      Buffer5[i]=0;
      j = iBarShift( NULL, PERIOD_M5, iTime(NULL, PERIOD_M5, ii), FALSE);
      s2 = 1;
      if(PERIOD_M1<=PERIOD_M5 && UseM5)
      {
      Buffer5[i]=(iMA(Master_pair,PERIOD_M5,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Master_pair,PERIOD_M5,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j))-
      (iMA(Slave_pair,PERIOD_M5,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Slave_pair,PERIOD_M5,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j));
      if(Buffer5[i]>Pogreshnost*Point || Buffer5[i]<-Pogreshnost*Point) s2 = 0;
      }
      Buffer15[i]=0;
      j = iBarShift( NULL, PERIOD_M15, iTime(NULL, PERIOD_M5, ii), FALSE);
      s3 = 1;
      if(PERIOD_M1<=PERIOD_M15 && UseM15)
      {
      Buffer15[i]=(iMA(Master_pair,PERIOD_M15,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Master_pair,PERIOD_M15,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j))-
      (iMA(Slave_pair,PERIOD_M15,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Slave_pair,PERIOD_M15,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j));
      if(Buffer15[i]>Pogreshnost*Point || Buffer15[i]<-Pogreshnost*Point) s3 = 0;
      }
      Buffer30[i]=0;
      j = iBarShift( NULL, PERIOD_M30, iTime(NULL, PERIOD_M5, ii), FALSE);
      s4 = 1;
      if(PERIOD_M1<=PERIOD_M30 && UseM30)
      {
      Buffer30[i]=(iMA(Master_pair,PERIOD_M30,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Master_pair,PERIOD_M30,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j))-
      (iMA(Slave_pair,PERIOD_M30,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Slave_pair,PERIOD_M30,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j));
      if(Buffer30[i]>Pogreshnost*Point || Buffer30[i]<-Pogreshnost*Point) s4 = 0;
      }
      BufferH1[i]=0;
      j = iBarShift( NULL, PERIOD_H1, iTime(NULL, PERIOD_M5, ii), FALSE);
      s5 = 1;
      if(PERIOD_M1<=PERIOD_H1 && UseH1)
      {
      BufferH1[i]=(iMA(Master_pair,PERIOD_H1,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Master_pair,PERIOD_H1,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j))-
      (iMA(Slave_pair,PERIOD_H1,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Slave_pair,PERIOD_H1,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j));
      if(BufferH1[i]>Pogreshnost*Point || BufferH1[i]<-Pogreshnost*Point) s5 = 0;
      }
      BufferH4[i]=0;
      j = iBarShift( NULL, PERIOD_H4, iTime(NULL, PERIOD_M5, ii), FALSE);
      s6 = 1;
      if(PERIOD_M1<=PERIOD_H4 && UseH4)
      {
      BufferH4[i]=(iMA(Master_pair,PERIOD_H4,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Master_pair,PERIOD_H4,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j))-
      (iMA(Slave_pair,PERIOD_H4,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Slave_pair,PERIOD_H4,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j));
      if(BufferH4[i]>Pogreshnost*Point || BufferH4[i]<-Pogreshnost*Point) s6 = 0;
      }
      BufferD1[i]=0;
      j = iBarShift( NULL, PERIOD_D1, iTime(NULL, PERIOD_M5, ii), FALSE);
      s7 = 1;
      if(PERIOD_M1<=PERIOD_D1 && UseD1)
      {
      BufferD1[i]=(iMA(Master_pair,PERIOD_D1,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Master_pair,PERIOD_D1,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j))-
      (iMA(Slave_pair,PERIOD_D1,FastEMA,0,MODE_EMA,PRICE_CLOSE,j)-iMA(Slave_pair,PERIOD_D1,SlowEMA,0,MODE_EMA,PRICE_CLOSE,j));
      if(BufferD1[i]>Pogreshnost*Point || BufferD1[i]<-Pogreshnost*Point) s7 = 0;
      }
      BufferSig[i] = EMPTY_VALUE;
      if(s1 == 1 && s2 ==1 && s3 ==1 && s4 ==1 && s5 ==1 && s6 ==1 && s7 ==1) BufferSig[i] = 0;
    }
/////////////////////////////////////////
//---- done
   return(0);
  }
//+------------------------------------------------------------------+-----------------+