//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

double CrossUp[];
double CrossDown[];

extern string  P1  = " MACD";
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
extern double buffersize = 20; //

extern string  P2  = " ";
extern int Candle=40; //  


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int counter;
   
   double MACD_Main, MACD_Signal, MACD_MainPrevious, MACD_SignalPrevious;
   double Range, AvgRange;
   double MA_F, MA_S;
   double Candle_Size;
   
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   for (int i = 0; i <= limit; i++) 
   {   
      counter = i;
      Range = 0;
      AvgRange = 0;
      CrossUp[i] = 0;
      CrossDown[i] = 0;
      for (counter = i; counter <= i + 9; counter++) 
      AvgRange += MathAbs(High[counter] - Low[counter]);

      Range = AvgRange / 10;
//+------------------------------------------------------------------+      
      MACD_Main = iMACD(NULL, 0, FastEMA, SlowEMA, SignalSMA, PRICE_CLOSE, MODE_MAIN, i);
      MACD_MainPrevious = iMACD(NULL, 0, FastEMA, SlowEMA, SignalSMA, PRICE_CLOSE, MODE_MAIN, i+1);
      MACD_Signal = iMACD(NULL, 0, FastEMA, SlowEMA, SignalSMA, PRICE_CLOSE, MODE_SIGNAL, i);
      MACD_SignalPrevious = iMACD(NULL, 0, FastEMA, SlowEMA, SignalSMA, PRICE_CLOSE, MODE_SIGNAL, i+1);

      MA_F = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i);
      MA_S = iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
     
      Candle_Size = MathAbs(Close[i] - Open[i]); // 
//+------------------------------------------------------------------+      
      if (
      MACD_Signal < MACD_Main && MACD_SignalPrevious > MACD_MainPrevious
      && MA_F-MA_S < buffersize*Point
      && MA_F-MA_S < -buffersize*Point
      && Candle_Size<(Candle*0.0001)
      ) {
         CrossUp[i] = Low[i] - Range*1;
      }
//+------------------------------------------------------------------+     
      else if (
      MACD_Signal > MACD_Main && MACD_SignalPrevious < MACD_MainPrevious
      && MA_F-MA_S > buffersize*Point
      && MA_F-MA_S > -buffersize*Point
      && Candle_Size<(Candle*0.0001)
      ) {
         CrossDown[i] = High[i] + Range*1;
      }
//+------------------------------------------------------------------+     
   }
   return(0);
}

