//+------------------------------------------------------------------+
//|                                                 Palpite_MACD.mq4 |
//|                                        Copyright  2016, Palpite |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Palpite"
#property link      ""

#property indicator_separate_window
#property indicator_height  150
#property indicator_buffers 4
#property indicator_color1  Red
#property indicator_color2  ForestGreen
#property indicator_color3  Yellow
#property indicator_color4  Cyan
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
//---- input parameters
extern int FastMAPeriod   = 12, 
           SlowMAPeriod   = 26,
           SignalMAPeriod = 9;
//---- buffers
double     MACDLineBuffer[],
           SignalLineBuffer[],
           HistogramBuffer[],
           HistogramBuffer1[],
           Signal,
           Signal_1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorDigits(Digits + 1);
   //---- indicators
   SetIndexStyle (0, DRAW_HISTOGRAM);        SetIndexBuffer   (0, HistogramBuffer) ; SetIndexLabel(0, "Histo");SetLevelValue(0, 0);SetLevelStyle(STYLE_DOT,1,DimGray);
   SetIndexStyle (1, DRAW_HISTOGRAM);        SetIndexBuffer   (1, HistogramBuffer1); SetIndexLabel(1, "Histo1");
   SetIndexStyle (2, DRAW_LINE, STYLE_SOLID);SetIndexDrawBegin(2, SlowMAPeriod)     ;SetIndexBuffer(2, MACDLineBuffer);
   SetIndexBuffer(3, SignalLineBuffer)      ;SetIndexDrawBegin(3, SlowMAPeriod - SignalMAPeriod); SetIndexLabel(3, "Signal");
   IndicatorShortName("   Palpite_MACD   (" + FastMAPeriod+" , " + SlowMAPeriod + " , " + SignalMAPeriod + ")");
   //----
	Signal   = 1.5 / (SignalMAPeriod - 1.0);
	Signal_1 = 1.0 - Signal;
   //----
   return(Digits);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   //----
   return(1);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
   //---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
   //---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
//----
   double value=0;
   for(int i = limit; i >= 0; i--)
     {
       MACDLineBuffer[i] = iMA(NULL, 0, FastMAPeriod, 0, MODE_EMA, PRICE_CLOSE, i) - iMA(NULL, 0, SlowMAPeriod, 0, MODE_EMA, PRICE_CLOSE, i);
       SignalLineBuffer[i]= Signal*MACDLineBuffer[i] + Signal_1*SignalLineBuffer[i+1];    
         HistogramBuffer[i] = MACDLineBuffer[i] - SignalLineBuffer[i]/100;
         HistogramBuffer1[i] = HistogramBuffer[i];
         if (value>SignalLineBuffer[i] - MACDLineBuffer[i]) HistogramBuffer[i]=value;
         if (value<SignalLineBuffer[i] - MACDLineBuffer[i]) HistogramBuffer1[i]=value;
     }
//----
   return(counted_bars);
  }