/*
iCustom(NULL,0,"_MACD_Xtr",FastMA,SlowMA,Source,SourcePeriod,FrontPeriod,xVolatility,Sens, N,i); 
*/
#property indicator_separate_window //   
#property indicator_buffers 5
#property indicator_color1 Blue // 
#property indicator_color2 Gray //  
#property indicator_color3 Gray //  
#property indicator_color4 Green //    
#property indicator_color5 Red //    

//  
   // MACD
extern int FastMA=12; //   EMA
extern int SlowMA=26; //   EMA
   // 
extern int Source=1; // : 0 - , 1 - ATR, 2 - .
extern int SourcePeriod=5; //  
      // 
 double FrontPeriod=1; //   ; .. <1
extern double BackPeriod=444; //   ; .. <1
   //  /
extern double xVolatility=0.5;
extern double Sens=0; //    .    ( )

 int History=0; // -  ; 0 - 

// .
double   MACD[], // MACD
         OB[], //  
         OS[], //  
         OBH[], //    
         OSH[]; //    
//  () 
bool first=1; //   
double sens; //    

// 
int init()
  {
   first=1;
   sens=Sens*Point; //    
   string _md="MACD("+FastMA+","+SlowMA+")";
   
   SetIndexBuffer(0,MACD);
   SetIndexStyle(0,DRAW_HISTOGRAM,0);
   SetIndexLabel(0,_md);

   SetIndexBuffer(1,OB);
   SetIndexStyle(1,DRAW_LINE,2);
   SetIndexLabel(1,"OB");

   SetIndexBuffer(2,OS);
   SetIndexStyle(2,DRAW_LINE,2);
   SetIndexLabel(2,"OS");

   SetIndexBuffer(3,OBH);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,2);
   SetIndexLabel(3,"Peak");

   SetIndexBuffer(4,OSH);
   SetIndexStyle(4,DRAW_HISTOGRAM,0,2);
   SetIndexLabel(4,"Trough");

   if(BackPeriod<1) string _bk=DoubleToStr(BackPeriod,3); else _bk=DoubleToStr(BackPeriod,0);
      // 
   if(Sens>0) string _src=DoubleToStr(Sens,1)+" "; 
      // 
   switch(Source) {
      case 0: _src=_src+"Volume"; break; // 
      case 1: _src=_src+"ATR"; break; // ATR
      case 2: _src=_src+"StDev"; // .
     }
   _src=_src+"("+SourcePeriod+","+_bk+")";

   IndicatorShortName(_md+" "+_src); 
   
   return(0);
  }

// -  
int reinit() 
  {
   ArrayInitialize(MACD,0.0); //  
   ArrayInitialize(OB,0.0); //  
   ArrayInitialize(OS,0.0); //  
   ArrayInitialize(OBH,0.0); //  
   ArrayInitialize(OSH,0.0); //  
   return(0);
  }

int start()
  {
   int ic=IndicatorCounted();
   if(!first && Bars-ic-1>1) ic=reinit(); //        - 
   bool ic0=ic==0; //  
   int limit=Bars-ic-1; // - 
   if(History!=0 && limit>History) limit=History-1; // -   

   for(int i=limit; i>=0; i--) { //     
      
      double macd=iMACD(NULL,0,FastMA,SlowMA,1,0, 0,i);
      MACD[i]=macd;

      double vlt=xVolatility*iCustom(NULL,0,"_Volatility_FBA_NR",Source,SourcePeriod,FrontPeriod,BackPeriod,0, 1,i);
      double lev=MathMax(sens,vlt);
      OB[i]=lev; OS[i]=-lev;

      if(macd> lev) OBH[i]=macd; else OBH[i]=0;
      if(macd<-lev) OSH[i]=macd; else OSH[i]=0;

     }   
   first=0; //    
   return(0);
  }



