/*
  ;    - ATR
double iCustom(
   string symbol,          //    (NULL- )
   int timeframe,          // - (0- )
   "iMACDATR",            //   

   //  
   double fast_ema_period, //   EMA; .. (>1)    - (<1)
   double slow_ema_period, //   EMA; .. (>1)    - (<1)
   int atr_period,         //  ATR,  =0,  atr_period=slow_ema_period
   int applied_price,      //  :
                              // 0 - PRICE_CLOSE -   
                              // 1 - PRICE_OPEN -  
                              // 2 - PRICE_HIGH - .
                              // 3 - PRICE_LOW - .
                              // 4 - PRICE_MEDIAN -  ,(high+low)/2
                              // 5 - PRICE_TYPICAL -  ,(high+low+close)/3
                              // 6 - PRICE_WEIGHTED -   ,(high+low+close+close)/4
   // 
   mode,                   // mode -   :
                              // 0 - 
                              // 1 -  +/- ATR
                              // 2 - 
                              // 3 - 
   //
   int shift               // 
   ) 

==============

iCustom(NULL,0,"iMACDATR",FastEMA,SlowEMA,ATR,Price, 0,i);
*/

#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Gray // MACD
#property  indicator_color2  Blue // MACDATR
#property  indicator_color3  Green // 
#property  indicator_color4  Red // 

//  
extern double FastEMA=12; //   EMA; .. (>1)    - (<1)
   double f0;
extern double SlowEMA=26; //   EMA; .. (>1)    - (<1)
   double s0;
extern int ATR=0; //  ATR,  =0,  ATR=SlowEMA
 double kATR=1; //  
 double ATRmin=0; //    ATR  .
extern int Price=0; //  :
 int History=0; // 0-  

double   MACD[], // MACD
         TR[], // MACDATR
         UP[],DN[]; // 
double fper,sper; //  

void init() { 
   if(FastEMA>1) {f0=2/(1+FastEMA); fper=FastEMA;}
   else {f0=FastEMA; fper=(2-FastEMA)/FastEMA;}
   if(SlowEMA>1) {s0=2/(1+SlowEMA); sper=SlowEMA;}
   else {s0=SlowEMA; sper=(2-SlowEMA)/SlowEMA;}
   
   if(ATR==0) ATR=SlowEMA; 
   string _atrmin=DoubleToStr(ATRmin,1);
   ATRmin*=Point; //    ATR  

   IndicatorDigits(5);
   // MACD
   string _macd="MACD("+DoubleToStr(fper,2)+","+DoubleToStr(sper,2);
   SetIndexBuffer(0,MACD); 
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexLabel(0,_macd+")");
   SetIndexEmptyValue(0,0.0);
   // MACDATR
   string _tr=""+ATR+")";
   SetIndexBuffer(1,TR); 
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"TR("+_tr);
   SetIndexEmptyValue(1,0.0);
   // 
   SetIndexBuffer(2,UP); 
   SetIndexStyle(2,DRAW_HISTOGRAM,1,2);
   SetIndexLabel(2,"Peak");
   // 
   SetIndexBuffer(3,DN); 
   SetIndexStyle(3,DRAW_HISTOGRAM,1,2);
   SetIndexLabel(3,"Trough");
   
   if(ATRmin>0) _macd=_atrmin+" "+_macd;
   IndicatorShortName(_macd+","+_tr);
  }

void start() {
   int limit=Bars-IndicatorCounted()-1; 
   if(limit>1) limit=MathMin(Bars,History+(History==0)*Bars)-1;
   //  
   for(int i=limit; i>=0; i--) { 
      // MACD
      double c=iMA(NULL,0,1,0,0,Price, i); // 
      static double fm1,sm1; // EMAs previous
      if(i==limit && i>1) {fm1=c;sm1=c;} //  
      double fm0=f0*c+(1-f0)*fm1; // fast MA
      double sm0=s0*c+(1-s0)*sm1; // slow MA
      MACD[i]=fm0-sm0; // MACD
      // MACDATR
      double atr=kATR*iATR(NULL,0,ATR, i); // ATR
      atr=MathMax(atr,ATRmin); //  
      if(MACD[i]>0) TR[i]=MACD[i]-atr; //    MACD
      if(MACD[i]<0) TR[i]=MACD[i]+atr; //    MACD
      // 
      if(MACD[i]>0 && MACD[i+1]<MACD[i] && TR[i]>=0) UP[i]=MACD[i]; // 
      if(MACD[i]<0 && MACD[i+1]>MACD[i] && TR[i]<=0) DN[i]=MACD[i]; // 
      
      // 
      if(i>0) {fm1=fm0; sm1=sm0;}
     }
  }

