//+------------------------------------------------------------------+
//|                                                    iZMI_MACD.mq4 |
//|                                  Copyright  2009, Maxim Zemskov |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Maxim Zemskov"
#property link      "http://moneytrading.at.ua"

#property indicator_separate_window
#property indicator_buffers   10
#property indicator_color1    DodgerBlue
#property indicator_width1    2
#property indicator_color2    Green
#property indicator_width2    2
#property indicator_color3    Lime
#property indicator_width3    2
#property indicator_color4    DodgerBlue
#property indicator_width4    2
#property indicator_color5    FireBrick
#property indicator_width5    2
#property indicator_color6    Red
#property indicator_width6    2
#property indicator_color7    Yellow
#property indicator_width7    2
#property indicator_color8    MediumBlue
#property indicator_width8    2

//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;

double MACD_LINEMABuffer[];
double MACDBufferStartUp[];
double MACDBufferUp[];
double MACDBufferFlet[];
double MACDBufferStartDown[];
double MACDBufferDown[];
double MACDBufferNotDefine[];
double EMA_SIGNALBuffer[];

int init()
  {
   SetIndexBuffer(0, MACD_LINEMABuffer);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(1, MACDBufferStartUp);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexBuffer(2, MACDBufferUp);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexBuffer(3, MACDBufferFlet);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexBuffer(4, MACDBufferStartDown);
   SetIndexStyle(4, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexBuffer(5, MACDBufferDown);
   SetIndexStyle(5, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexBuffer(6, MACDBufferNotDefine);
   SetIndexStyle(6, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexBuffer(7, EMA_SIGNALBuffer);
   SetIndexStyle(7, DRAW_LINE, STYLE_SOLID, 2);

   // Names and labels
   IndicatorShortName( "ZMI_MACD(" + FastEMA + "," + SlowEMA + "," + SignalSMA);
   SetIndexLabel(1, "Start UP TREND");
   SetIndexLabel(2, "UP TREND");
   SetIndexLabel(3, "Flet");
   SetIndexLabel(4, "Start DOWN TREND");
   SetIndexLabel(5, "DOWN TREND");
   
   return(0);
  }

int deinit()
  {
//----
   
//----
   return(0);
  }

int start()
  {
   int limit;
   int i, counted_bars;

   double MACD_Current, MACD_Previous;

   counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(i=0; i<limit; i++) {
      MACD_LINEMABuffer[i]=iMA(NULL,0,FastEMA,0,MODE_LWMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_LWMA,PRICE_CLOSE,i);
   }
   for(i=0; i<limit; i++) {
      EMA_SIGNALBuffer[i]=iMAOnArray(MACD_LINEMABuffer,Bars,SignalSMA,0,MODE_LWMA,i);
   }
   for(i=0; i<limit; i++) {
      MACD_Current = iOsMA(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,i);
      MACD_Previous = iOsMA(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,i + 1);   
      if ((MACD_Current > MACD_Previous) &&
          (MACD_LINEMABuffer[i] > MACD_LINEMABuffer[i+1]) &&
          (EMA_SIGNALBuffer[i] <= EMA_SIGNALBuffer[i+1])
         ) {
            MACDBufferStartUp[i] = MACD_Current;
         }
      else if ((MACD_Current > MACD_Previous) &&
          (MACD_LINEMABuffer[i] > MACD_LINEMABuffer[i+1]) &&
          (EMA_SIGNALBuffer[i] > EMA_SIGNALBuffer[i+1])
         ) {
            MACDBufferUp[i] = MACD_Current;
         }
      else if (
          ((MACD_Current >= MACD_Previous) &&
           (EMA_SIGNALBuffer[i] <= EMA_SIGNALBuffer[i+1]) &&
           ((MACD_LINEMABuffer[i] <= MACD_LINEMABuffer[i+1]))
          ) ||
          ((MACD_Current <= MACD_Previous) &&
           (EMA_SIGNALBuffer[i] >= EMA_SIGNALBuffer[i+1]) &&
           ((MACD_LINEMABuffer[i] >= MACD_LINEMABuffer[i+1]))
          )
         ) {
            MACDBufferFlet[i]=MACD_Current;
         }
      else if ((MACD_Current < MACD_Previous) &&
          (MACD_LINEMABuffer[i] < MACD_LINEMABuffer[i+1]) &&
          (EMA_SIGNALBuffer[i] >= EMA_SIGNALBuffer[i+1])
         ) {
            MACDBufferStartDown[i] = MACD_Current;
         }
      else if ((MACD_Current < MACD_Previous) &&
          (MACD_LINEMABuffer[i] < MACD_LINEMABuffer[i+1]) &&
          (EMA_SIGNALBuffer[i] < EMA_SIGNALBuffer[i+1])
         ) {
            MACDBufferDown[i] = MACD_Current;
         }
      else {
         MACDBufferNotDefine[i]=MACD_Current;
      }
   }

   return(0);
  }