//+------------------------------------------------------------------+
//|                                                          macd HL |
//|                                                           mladen |
//|                                                                  |
//| forex-tsd elite section only indicator                           |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"


#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Magenta
#property indicator_color3  Red
#property indicator_color4  Red
#property indicator_color5  LimeGreen
#property indicator_color6  LimeGreen
#property indicator_color7  Goldenrod
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style7  STYLE_DASH
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  4
#property indicator_width6  4


//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    FastJMA          = 20;
extern int    SlowJMA          = 50;
extern int    FastJMAPhase     = 0;
extern int    SlowJMAPhase     = 0;
extern int    SignalLength     =  9;
extern int    ApplyTo          = PRICE_CLOSE;
extern int    LookBackLength   = 50;
extern double UpEarlyLevel     = 0.5;
extern double DownEarlyLevel   = 0.5;
extern bool   ShowArrows       = true;
extern string ArrowsIdentifier = "macd HL";
extern color  ArrowUpColor     = Aqua;
extern color  ArrowDownColor   = Red;
extern bool   Interpolate      = true;

//
//
//
//
//

double macd[];
double macds[];
double macdhh[];
double macdhe[];
double macdll[];
double macdle[];
double macdzl[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,macd);   SetIndexLabel(0,"macd");
   SetIndexBuffer(1,macds);  SetIndexLabel(1,"macd signal line");
   SetIndexBuffer(2,macdhh); SetIndexLabel(2,"macd high");
   SetIndexBuffer(3,macdhe); SetIndexLabel(3,"macd upper early");
   SetIndexBuffer(4,macdle); SetIndexLabel(4,"macd lower early");
   SetIndexBuffer(5,macdll); SetIndexLabel(5,"macd low");
   SetIndexBuffer(6,macdzl); SetIndexLabel(6,"macd zero line");
   SetIndexBuffer(7,trend);
   
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="CalculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   
   //
   //
   //
   //
   //

   IndicatorShortName(timeFrameToString(timeFrame)+" macd HL ("+FastJMA+","+SlowJMA+","+SignalLength+","+LookBackLength+","+DoubleToStr(UpEarlyLevel,3)+","+DoubleToStr(DownEarlyLevel,3)+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   if (ShowArrows)
   {
      int compareLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,compareLength) == ArrowsIdentifier)
                ObjectDelete(name);  
      }
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit;
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
            limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars)  { macd[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
 
   if (calculateValue || timeFrame == Period())
   {
      double alpha = 2.0 / (1.0+SignalLength);
      for(i=limit; i>=0; i--)
      {
         macd[i] = iSmooth(iMA(NULL,0,1,0,MODE_SMA,ApplyTo,i),FastJMA,FastJMAPhase,i,0) - iSmooth(iMA(NULL,0,1,0,MODE_SMA,ApplyTo,i),SlowJMA,SlowJMAPhase,i,10);
         if (i==(Bars-1))
               macds[i] = macd[i];
         else  macds[i] = macds[i+1]+alpha*(macd[i]-macds[i+1]);
      
         //
         //
         //
         //
         //
      
         double macdMax=macd[i];
         double macdMin=macd[i];
            for (int k=1; (i+k)<Bars && k<LookBackLength; k++)
            {
               macdMax = MathMax(macd[i+k],macdMax);
               macdMin = MathMin(macd[i+k],macdMin);
            }
         macdhh[i] =  macdMax;
         macdll[i] =  macdMin;
         macdzl[i] = (macdMax+macdMin)/2.0;
         macdhe[i] = macdzl[i]+(macdhh[i]-macdzl[i])*UpEarlyLevel;
         macdle[i] = macdzl[i]-(macdzl[i]-macdll[i])*DownEarlyLevel;
         
         //
         //
         //
         //
         //

         manageArrow(i);      
      }                  
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         macd[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateAlfr",FastJMA,SlowJMA,FastJMAPhase,SlowJMAPhase,SignalLength,ApplyTo,LookBackLength,UpEarlyLevel,DownEarlyLevel,0,y);
         macds[i]  = iCustom(NULL,timeFrame,indicatorFileName,"CalculateAlfr",FastJMA,SlowJMA,FastJMAPhase,SlowJMAPhase,SignalLength,ApplyTo,LookBackLength,UpEarlyLevel,DownEarlyLevel,1,y);
         macdhh[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateAlfr",FastJMA,SlowJMA,FastJMAPhase,SlowJMAPhase,SignalLength,ApplyTo,LookBackLength,UpEarlyLevel,DownEarlyLevel,2,y);
         macdhe[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateAlfr",FastJMA,SlowJMA,FastJMAPhase,SlowJMAPhase,SignalLength,ApplyTo,LookBackLength,UpEarlyLevel,DownEarlyLevel,3,y);
         macdle[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateAlfr",FastJMA,SlowJMA,FastJMAPhase,SlowJMAPhase,SignalLength,ApplyTo,LookBackLength,UpEarlyLevel,DownEarlyLevel,4,y);
         macdll[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateAlfr",FastJMA,SlowJMA,FastJMAPhase,SlowJMAPhase,SignalLength,ApplyTo,LookBackLength,UpEarlyLevel,DownEarlyLevel,5,y);
         macdzl[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateAlfr",FastJMA,SlowJMA,FastJMAPhase,SlowJMAPhase,SignalLength,ApplyTo,LookBackLength,UpEarlyLevel,DownEarlyLevel,6,y);
         manageArrow(i);      

         //
         //
         //
         //
         //
      
         if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               macd[i+k]   = macd[i]  +(macd[i+n]  -macd[i])  *k/n;
               macds[i+k]  = macds[i] +(macds[i+n] -macds[i]) *k/n;
               macdhh[i+k] = macdhh[i]+(macdhh[i+n]-macdhh[i])*k/n;
               macdhe[i+k] = macdhe[i]+(macdhe[i+n]-macdhe[i])*k/n;
               macdle[i+k] = macdle[i]+(macdle[i+n]-macdle[i])*k/n;
               macdll[i+k] = macdll[i]+(macdll[i+n]-macdll[i])*k/n;
               macdzl[i+k] = macdzl[i]+(macdzl[i+n]-macdzl[i])*k/n;
            }               
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


void manageArrow(int i)
{
   if (ShowArrows && !calculateValue)
   {
      double dist = iATR(NULL,0,20,i)/2.0;
      ObjectDelete(ArrowsIdentifier+Time[0]);         
            
      //
      //
      //
      //
      //
           
      trend[i] = trend[i+1];
         if (macd[i]>macds[i]) trend[i] =  1;
         if (macd[i]<macds[i]) trend[i] = -1;
         if (trend[i] !=trend[i+1])
         {
            string name = ArrowsIdentifier+Time[i];
            if (trend[i] == 1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,241);
                  ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
            }
            else
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,242);
                  ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
            }
         }
   }
}


  
double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

  
double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}