#property link      "www.forex-tsd.com"      
#property copyright "www.forex-tsd.com"                           

#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     clrRed
#property indicator_color2     clrMaroon
#property indicator_color3     clrLime
#property indicator_color4     clrGreen
#property indicator_color5     clrDodgerBlue
#property indicator_color6     clrCoral 
#property indicator_width1     2
#property indicator_width2     1
#property indicator_width3     2
#property indicator_width4     1
#property indicator_width5     2
#property indicator_width6     2

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

extern ENUM_TIMEFRAMES TimeFrame         = PERIOD_CURRENT;
extern int             FastJma           = 12;
extern double          FastPhase         = 0;
extern bool            FastDouble        = false;
extern int             SlowJma           = 26;
extern double          SlowPhase         = 0;
extern bool            SlowDouble        = false;
extern int             SignalJma         = 9;
extern double          SignalPhase       = 0;
extern bool            SignalDouble      = false;
extern enPrices        Price             = pr_close; // Price to use 
extern bool            HistogramOnSlope  = true;
extern bool            arrowsVisible     = true;
extern bool            arrowsOnFirst     = false;
extern bool            arrowsOnSlope     = false;
extern bool            arrowsOnZeroCross = true;
extern string          arrowsIdentifier  = "jmacd arrows1";
extern double          arrowsUpperGap    = 0.5;
extern double          arrowsLowerGap    = 0.5;
extern color           arrowsUpColor     = clrLimeGreen;
extern color           arrowsDnColor     = clrRed;
extern int             arrowsUpCode      = 241;
extern int             arrowsDnCode      = 242;
extern bool            alertsOn          = true;
extern bool            alertsOnCurrent   = false;
extern bool            alertsOnSlope     = false;
extern bool            alertsOnZeroCross = true;
extern bool            alertsMessage     = true;
extern bool            alertsSound       = false;
extern bool            alertsNotify      = false;
extern bool            alertsEmail       = false;
extern string          soundFile         = "alert2.wav";
extern bool            Interpolate       = true;

double jmacd[];
double signal[];
double Upa[];
double Upb[];
double Dna[];
double Dnb[];
double slope[];
double trend[];
string indicatorFileName;
bool   returnBars;

//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,Dna);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dnb);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Upa);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,Upb);   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,jmacd); 
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trend);
   
         //
         //
         //
         //
         //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);

         //
         //
         //
         //
         //
         
   IndicatorShortName(timeFrameToString(TimeFrame)+" jurik macd ("+FastJma+","+SlowJma+","+SignalJma+")");
return(0);
}
int deinit()
{
   deleteArrows();

return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Dna[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame==Period())
   {
   
     for(i=limit; i>=0; i--) jmacd[i] = iDSmooth(getPrice(Price,Open,Close,High,Low,i),FastJma,FastPhase,FastDouble,i, 0) - 
                                        iDSmooth(getPrice(Price,Open,Close,High,Low,i),SlowJma,SlowPhase,SlowDouble,i,20);
     for(i=limit; i>=0; i--) 
   {
        signal[i] = iDSmooth(jmacd[i],SignalJma,SignalPhase,SignalDouble,i,40);
        Dna[i]    = EMPTY_VALUE;
        Dnb[i]    = EMPTY_VALUE;
        Upa[i]    = EMPTY_VALUE;
        Upb[i]    = EMPTY_VALUE;
        slope[i]  = slope[i+1];
        trend[i]  = trend[i+1];
           if (jmacd[i] > 0)          trend[i] =  1;
           if (jmacd[i] < 0)          trend[i] = -1;
           if (jmacd[i] > jmacd[i+1]) slope[i] =  1;
           if (jmacd[i] < jmacd[i+1]) slope[i] = -1;
               
           if (HistogramOnSlope)
           {
             if (trend[i]== 1 && slope[i] == 1) Upa[i] = jmacd[i];
             if (trend[i]== 1 && slope[i] ==-1) Upb[i] = jmacd[i];
             if (trend[i]==-1 && slope[i] ==-1) Dna[i] = jmacd[i];
             if (trend[i]==-1 && slope[i] == 1) Dnb[i] = jmacd[i];
           }
           else
           {                  
             if (trend[i]== 1) Upa[i] = jmacd[i];
             if (trend[i]==-1) Dna[i] = jmacd[i];  
           }
           
           if (arrowsVisible)
           {
              ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
              ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
              string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
              if (arrowsOnSlope && slope[i] != slope[i+1])
              {
                if (slope[i] == 1) drawArrow("1",0.5,i,arrowsUpColor,arrowsUpCode,false);
                if (slope[i] ==-1) drawArrow("1",0.5,i,arrowsDnColor,arrowsDnCode,true);
              }
              if (arrowsOnZeroCross && trend[i] != trend[i+1])
              {
                if (trend[i] == 1) drawArrow("2",1,i,arrowsUpColor,arrowsUpCode,false);
                if (trend[i] ==-1) drawArrow("2",1,i,arrowsDnColor,arrowsDnCode,true);
              }
              
            }
     } 
      
     //
     //
     //
     //
     //
         
     if (alertsOn)
     {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        static datetime time1 = 0;
        static string   mess1 = "";
        if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
        {
           if (slope[whichBar] ==  1 ) doAlert(time1,mess1,whichBar,"sloping up");
           if (slope[whichBar] == -1 ) doAlert(time1,mess1,whichBar,"sloping down");
        }         
        static datetime time2 = 0;
        static string   mess2 = "";
        if (alertsOnZeroCross && trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar] ==  1 ) doAlert(time2,mess2,whichBar,"crossing zero up");
           if (trend[whichBar] == -1 ) doAlert(time2,mess2,whichBar,"crossing zero down");
        }         
     }           
     return(0);
  }
  
  //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         Dna[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastJma,FastPhase,FastDouble,SlowJma,SlowPhase,SlowDouble,SignalJma,SignalPhase,SignalDouble,Price,HistogramOnSlope,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
         Dnb[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastJma,FastPhase,FastDouble,SlowJma,SlowPhase,SlowDouble,SignalJma,SignalPhase,SignalDouble,Price,HistogramOnSlope,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
         Upa[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastJma,FastPhase,FastDouble,SlowJma,SlowPhase,SlowDouble,SignalJma,SignalPhase,SignalDouble,Price,HistogramOnSlope,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
         Upb[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastJma,FastPhase,FastDouble,SlowJma,SlowPhase,SlowDouble,SignalJma,SignalPhase,SignalDouble,Price,HistogramOnSlope,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
         jmacd[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastJma,FastPhase,FastDouble,SlowJma,SlowPhase,SlowDouble,SignalJma,SignalPhase,SignalDouble,Price,HistogramOnSlope,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,4,y);
         signal[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastJma,FastPhase,FastDouble,SlowJma,SlowPhase,SlowDouble,SignalJma,SignalPhase,SignalDouble,Price,HistogramOnSlope,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,5,y);

          //
          //
          //
          //
          //
            
          if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,TimeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
             for(int s = 1; s < n; s++) 
             {
  	             jmacd[i+s]  = jmacd[i]  + (jmacd[i+n]  - jmacd[i])  * s/n;
  	             signal[i+s] = signal[i] + (signal[i+n] - signal[i]) * s/n;
  	             if (Dna[i]!= EMPTY_VALUE) Dna[i+s] = jmacd[i+s];
  	             if (Dnb[i]!= EMPTY_VALUE) Dnb[i+s] = jmacd[i+s];
  	             if (Upa[i]!= EMPTY_VALUE) Upa[i+s] = jmacd[i+s];
  	             if (Upb[i]!= EMPTY_VALUE) Upb[i+s] = jmacd[i+s];
              }
   }
return(0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][60];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

return(wrk[r][4+s]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!arrowsOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," jurik macd ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," jurik macd "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}
           

  