//+------------------------------------------------------------------+
//|                                                      Leader MACD |
//|                                                   LeaderMACD.mq4 |
//|                                                           mladen |
//|                                                                  |
//| TASC jul 2008                                                    |
//| Giorgos Siligardos                                               |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Blue
#property  indicator_color2  Red

//
//
//
//
//

extern int FastEMA   = 12;
extern int SlowEMA   = 26;
extern int SignalEMA =  9;

//
//
//
//
//

double leader[];
double signal[];
double tBuffer[][5];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,leader);
   SetIndexBuffer(1,signal);
   IndicatorShortName("Leader MACD ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iFastEma 0
#define iSlowEma 1
#define iFastEmd 2
#define iSlowEmd 3
#define iSmoothl 4

int start()
{
   int i,r,limit;
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
            limit=Bars-counted_bars;
            if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);
 
   //
   //
   //
   //
   //
 
   double alphaFast = 2.0 /(1.0+FastEMA);
   double alphaSlow = 2.0 /(1.0+SlowEMA);
   double alphaSign = 2.0 /(1.0+SignalEMA);
   
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         tBuffer[r][iFastEma] = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i);
         tBuffer[r][iSlowEma] = iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
         tBuffer[r][iFastEmd] = tBuffer[r-1][iFastEmd] + alphaFast*(Close[i]-tBuffer[r][iFastEma]-tBuffer[r-1][iFastEmd]);
         tBuffer[r][iSlowEmd] = tBuffer[r-1][iSlowEmd] + alphaSlow*(Close[i]-tBuffer[r][iSlowEma]-tBuffer[r-1][iSlowEmd]);
         
         //
         //
         //
         //
         //
         
         leader[i] = tBuffer[r][iFastEma] + tBuffer[r][iFastEmd] - tBuffer[r][iSlowEma] - tBuffer[r][iSlowEmd];
                     tBuffer[r][iSmoothl] = tBuffer[r-1][iSmoothl] + alphaSign*(leader[i]-tBuffer[r-1][iSmoothl]);
         signal[i] = leader[i]-tBuffer[r][iSmoothl];
      }                  
   return(0);
}