#property copyright "Copyright  2007, FX5"
#property link      "hazem@uk2.net"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 FireBrick
#property indicator_color3 Green
#property indicator_color4 Red

extern string separator1 = "*** OSMA Settings ***";
extern int fastEMA = 12;
extern int slowEMA = 26;
extern int signal = 9;
extern string separator2 = "*** Indicator Settings ***";
extern bool drawDivergenceLines = TRUE;
extern bool Alert_SoundON = TRUE;
extern bool EmailON = FALSE;
double G_ibuf_116[];
double G_ibuf_120[];
double G_ibuf_124[];
double G_ibuf_128[];
double G_ibuf_132[];
datetime G_time_136;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   IndicatorBuffers(5);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexStyle(4, DRAW_NONE);
   SetIndexBuffer(0, G_ibuf_116);
   SetIndexBuffer(1, G_ibuf_120);
   SetIndexBuffer(2, G_ibuf_124);
   SetIndexBuffer(3, G_ibuf_128);
   SetIndexBuffer(4, G_ibuf_132);
   SetIndexArrow(2, 233);
   SetIndexArrow(3, 234);
   IndicatorDigits(Digits + 2);
   IndicatorShortName("MACD Divergence Indicator v2.1(" + fastEMA + "," + slowEMA + "," + signal + ")");
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   string name_4;
   for (int Li_0 = ObjectsTotal() - 1; Li_0 >= 0; Li_0--) {
      name_4 = ObjectName(Li_0);
      if (StringSubstr(name_4, 0, 14) == "DivergenceLine") ObjectDelete(name_4);
   }
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   int ind_counted_0 = IndicatorCounted();
   if (ind_counted_0 < 0) ind_counted_0 = 0;
   f0_8(ind_counted_0);
   return (0);
}

// D56848A2C0A935EE72F1D2B79A260D92
void f0_8(int Ai_0) {
   for (int Li_4 = Bars - Ai_0; Li_4 >= 0; Li_4--) {
      f0_2(Li_4);
      f0_3(Li_4 + 2);
      f0_0(Li_4 + 2);
   }
}

// 827F74135063AA46EE0073626124657E
void f0_2(int Ai_0) {
   G_ibuf_132[Ai_0] = iOsMA(NULL, 0, fastEMA, slowEMA, signal, PRICE_CLOSE, Ai_0);
   if (G_ibuf_132[Ai_0] > 0.0) {
      G_ibuf_116[Ai_0] = G_ibuf_132[Ai_0];
      G_ibuf_120[Ai_0] = 0;
      return;
   }
   if (G_ibuf_132[Ai_0] < 0.0) {
      G_ibuf_120[Ai_0] = G_ibuf_132[Ai_0];
      G_ibuf_116[Ai_0] = 0;
      return;
   }
   G_ibuf_116[Ai_0] = 0;
   G_ibuf_120[Ai_0] = 0;
}

// 8A26275C9D3AC718392DD23A251DCDE0
void f0_3(int Ai_0) {
   int Li_4;
   int Li_8;
   if (f0_10(Ai_0) != 0) {
      Li_4 = Ai_0;
      Li_8 = f0_6(Ai_0);
      if (G_ibuf_132[Li_4] > G_ibuf_132[Li_8] && Low[Li_4] < Low[Li_8]) {
         G_ibuf_124[Li_4] = G_ibuf_132[Li_4];
         if (drawDivergenceLines == TRUE) {
            f0_5(Time[Li_4], Time[Li_8], Low[Li_4], Low[Li_8], Green, STYLE_SOLID);
            f0_9(Time[Li_4], Time[Li_8], G_ibuf_132[Li_4], G_ibuf_132[Li_8], Green, STYLE_SOLID);
         }
         if (Alert_SoundON || EmailON) f0_11("Classical bullish divergence on: ", Li_4);
      }
      if (G_ibuf_132[Li_4] < G_ibuf_132[Li_8] && Low[Li_4] > Low[Li_8]) {
         G_ibuf_124[Li_4] = G_ibuf_132[Li_4];
         if (drawDivergenceLines == TRUE) {
            f0_5(Time[Li_4], Time[Li_8], Low[Li_4], Low[Li_8], Green, STYLE_DOT);
            f0_9(Time[Li_4], Time[Li_8], G_ibuf_132[Li_4], G_ibuf_132[Li_8], Green, STYLE_DOT);
         }
         if (Alert_SoundON || EmailON) f0_11("Reverse bullish divergence on: ", Li_4);
      }
   }
}

// 5FC1B0AFD6B521CD7F11BBC56AF8119B
void f0_0(int Ai_0) {
   int Li_4;
   int Li_8;
   if (f0_7(Ai_0) != 0) {
      Li_4 = Ai_0;
      Li_8 = f0_4(Ai_0);
      if (G_ibuf_132[Li_4] < G_ibuf_132[Li_8] && High[Li_4] > High[Li_8]) {
         G_ibuf_128[Li_4] = G_ibuf_132[Li_4];
         if (drawDivergenceLines == TRUE) {
            f0_5(Time[Li_4], Time[Li_8], High[Li_4], High[Li_8], Red, STYLE_SOLID);
            f0_9(Time[Li_4], Time[Li_8], G_ibuf_132[Li_4], G_ibuf_132[Li_8], Red, STYLE_SOLID);
         }
         if (Alert_SoundON || EmailON) f0_11("Classical bearish divergence on: ", Li_4);
      }
      if (G_ibuf_132[Li_4] > G_ibuf_132[Li_8] && High[Li_4] < High[Li_8]) {
         G_ibuf_128[Li_4] = G_ibuf_132[Li_4];
         if (drawDivergenceLines == TRUE) {
            f0_5(Time[Li_4], Time[Li_8], High[Li_4], High[Li_8], Red, STYLE_DOT);
            f0_9(Time[Li_4], Time[Li_8], G_ibuf_132[Li_4], G_ibuf_132[Li_8], Red, STYLE_DOT);
         }
         if (Alert_SoundON || EmailON) f0_11("Reverse bearish divergence on: ", Li_4);
      }
   }
}

// D063F18E338EFFCA30C7EE81D3E40D36
int f0_7(int Ai_0) {
   if (G_ibuf_132[Ai_0] > 0.0 && G_ibuf_132[Ai_0] > G_ibuf_132[Ai_0 + 1] && G_ibuf_132[Ai_0] > G_ibuf_132[Ai_0 - 1]) {
      for (int Li_4 = Ai_0 + 1; Li_4 < Bars; Li_4++) {
         if (G_ibuf_132[Li_4] < 0.0) return (1);
         if (G_ibuf_132[Li_4] > G_ibuf_132[Ai_0]) break;
      }
   }
   return (0);
}

// E14368135B7477FF25D83FDDF24F98BB
int f0_10(int Ai_0) {
   if (G_ibuf_132[Ai_0] < 0.0 && G_ibuf_132[Ai_0] < G_ibuf_132[Ai_0 + 1] && G_ibuf_132[Ai_0] < G_ibuf_132[Ai_0 - 1]) {
      for (int Li_4 = Ai_0 + 1; Li_4 < Bars; Li_4++) {
         if (G_ibuf_132[Li_4] > 0.0) return (1);
         if (G_ibuf_132[Li_4] < G_ibuf_132[Ai_0]) break;
      }
   }
   return (0);
}

// 9F48518FEF26543FFA784F6CFC8F8AF5
int f0_4(int Ai_0) {
   for (int Li_ret_4 = Ai_0 + 5; Li_ret_4 < Bars; Li_ret_4++)
      if (G_ibuf_132[Li_ret_4] >= G_ibuf_132[Li_ret_4 + 1] && G_ibuf_132[Li_ret_4] > G_ibuf_132[Li_ret_4 + 2] && G_ibuf_132[Li_ret_4] >= G_ibuf_132[Li_ret_4 - 1] && G_ibuf_132[Li_ret_4] > G_ibuf_132[Li_ret_4 - 2]) return (Li_ret_4);
   return (-1);
}

// C4727244EC549971C092F50C4F836D41
int f0_6(int Ai_0) {
   for (int Li_ret_4 = Ai_0 + 5; Li_ret_4 < Bars; Li_ret_4++)
      if (G_ibuf_132[Li_ret_4] <= G_ibuf_132[Li_ret_4 + 1] && G_ibuf_132[Li_ret_4] < G_ibuf_132[Li_ret_4 + 2] && G_ibuf_132[Li_ret_4] <= G_ibuf_132[Li_ret_4 - 1] && G_ibuf_132[Li_ret_4] < G_ibuf_132[Li_ret_4 - 2]) return (Li_ret_4);
   return (-1);
}

// EAC4E9E33F3538045A48AFD1169EE124
void f0_11(string As_0, int Ai_8) {
   string Ls_12;
   if (Ai_8 <= 2 && Time[Ai_8] != G_time_136) {
      G_time_136 = Time[Ai_8];
      Ls_12 = TimeToStr(TimeCurrent(), TIME_DATE) + " " + TimeHour(TimeCurrent()) + ":";
      if (TimeMinute(TimeCurrent()) < 10) Ls_12 = Ls_12 + "0";
      Ls_12 = Ls_12 + TimeMinute(TimeCurrent());
      if (Alert_SoundON) Alert(As_0, Symbol(), " on ", f0_1(Period()), " ", Ls_12);
      if (EmailON) SendMail(As_0 + Symbol(), "Date=" + Ls_12 + " on " + f0_1(Period()));
   }
}

// 7A7600C3E0DAB851283548DF08F4C5FC
string f0_1(int Ai_0) {
   switch (Ai_0) {
   case 1:
      return ("M1");
   case 5:
      return ("M5");
   case 15:
      return ("M15");
   case 30:
      return ("M30");
   case 60:
      return ("H1");
   case 240:
      return ("H4");
   case 1440:
      return ("D1");
   case 10080:
      return ("W1");
   case 43200:
      return ("MN");
   }
   return ("??");
}

// BB7834063222DD7F11EA528AD77C625D
void f0_5(int A_datetime_0, int A_datetime_4, double A_price_8, double A_price_16, color A_color_24, double A_style_28) {
   string name_36 = "DivergenceLine2.1# " + DoubleToStr(A_datetime_0, 0);
   ObjectDelete(name_36);
   ObjectCreate(name_36, OBJ_TREND, 0, A_datetime_0, A_price_8, A_datetime_4, A_price_16, 0, 0);
   ObjectSet(name_36, OBJPROP_RAY, FALSE);
   ObjectSet(name_36, OBJPROP_COLOR, A_color_24);
   ObjectSet(name_36, OBJPROP_STYLE, A_style_28);
}

// D9232D8DF8BD19559FE0CD126EF71196
void f0_9(int A_datetime_0, int A_datetime_4, double A_price_8, double A_price_16, color A_color_24, double A_style_28) {
   string name_40;
   int window_36 = WindowFind("MACD Divergence Indicator v2.1(" + fastEMA + "," + slowEMA + "," + signal + ")");
   if (window_36 >= 0) {
      name_40 = "DivergenceLine2.1$# " + DoubleToStr(A_datetime_0, 0);
      ObjectDelete(name_40);
      ObjectCreate(name_40, OBJ_TREND, window_36, A_datetime_0, A_price_8, A_datetime_4, A_price_16, 0, 0);
      ObjectSet(name_40, OBJPROP_RAY, FALSE);
      ObjectSet(name_40, OBJPROP_COLOR, A_color_24);
      ObjectSet(name_40, OBJPROP_STYLE, A_style_28);
   }
}