#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrOrangeRed
#property indicator_color3  clrOrangeRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property strict

extern int                RsiPeriod = 14;           // Rsi period
extern ENUM_APPLIED_PRICE Price     = PRICE_CLOSE;  // Price
extern int                FastEma   = 12;           // Fast macd period
extern int                SlowEma   = 26;           // Slow macd period

double macdofrsi[],macdofrsida[],macdofrsidb[],slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{ 
   IndicatorBuffers(4);
   SetIndexBuffer(0,macdofrsi); 
   SetIndexBuffer(1,macdofrsida); 
   SetIndexBuffer(2,macdofrsidb); 
   SetIndexBuffer(3,slope); 
      IndicatorShortName("MACD of RSI ("+(string)FastEma+","+(string)SlowEma+","+(string)RsiPeriod+")");
   return(0); 
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

      //
      //
      //
      //
      //
   
      if (slope[limit]==-1) CleanPoint(limit,macdofrsida,macdofrsidb);
      for(int i = limit; i >= 0; i--)
      {
         double price   = iRSI(NULL,0,RsiPeriod,Price,i);
         macdofrsi[i]   = iEma(price,FastEma,i,0)-iEma(price,SlowEma,i,1);
         macdofrsida[i] = EMPTY_VALUE;
         macdofrsidb[i] = EMPTY_VALUE;
            slope[i] = (i<Bars-1) ? (macdofrsi[i]>macdofrsi[i+1]) ? 1 : (macdofrsi[i]<macdofrsi[i+1]) ? -1 : slope[i+1] : 0;
            if (slope[i]==-1) PlotPoint(i,macdofrsida,macdofrsidb,macdofrsi);
      }         
      return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define emaInstances 2
double workEma[][emaInstances];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workEma[r][instanceNo] = price;
   if (r>1 && period>1)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+(2.0/(1.0+period))*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
         {
            if (first[i+2] == EMPTY_VALUE) 
                  { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
            else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
         }
   else  { first[i] = from[i]; second[i] = EMPTY_VALUE; }
}