
#property copyright "Khashayar Talebi"
#property link      "http://www.stct.info"


#property indicator_chart_window
 
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Orange

//---- input parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=5;
 
//---- buffers
double Cross_Up[];
double Cross_Down[];

double ZeroCross_Up[];
double ZeroCross_Down[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
 
//----  
   IndicatorBuffers(4);
   
   SetIndexBuffer(0,Cross_Up);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,108);
   
   SetIndexBuffer(1,Cross_Down);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,108);     

   SetIndexBuffer(2,ZeroCross_Up);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,233);
   
   SetIndexBuffer(3,ZeroCross_Down);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,234);  


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Relative Strength Index                                          |
//+------------------------------------------------------------------+
int start()
  {
     int limit;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
     
     for(int i=1; i<limit; i++)
       {
       ////////////
            double Range=0.0;
            double AvgRange=0.0;
            for (int j = i; j<=i+9; j++) AvgRange=AvgRange+MathAbs(High[j]-Low[j]);
		
            Range=AvgRange/10;
       
       ////////////
       double Signal_1 = iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,i);
       double Signal_2 = iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,i+1);
       
       
       double MACD_1 = iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,i);
       double MACD_2 = iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,i+1);
 
       
       if ( MACD_1>Signal_1 && MACD_2<= Signal_2 )  {Cross_Up  [i] = Low[i]-Range;}
       if ( MACD_1<Signal_1 && MACD_2>= Signal_2 )  {Cross_Down[i] = High[i]+Range;}
       
       //----------------
       if ( Signal_1>0 && Signal_2 < 0 )  {ZeroCross_Up   [i] = Low[i]-Range;}
       if ( Signal_1<0 && Signal_2 > 0 )  {ZeroCross_Down [i] = High[i]+Range;}
       
       
       } 
//---- done
   return(0);
  }
//+------------------------------------------------------------------+