//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Silver
#property indicator_color2  Silver
#property indicator_color3  PaleVioletRed
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1  0

//
//
//
//
//

enum enMaMethod
{
   ma_sma,  // simple moving average SMA 
   ma_ema,  // exponential moving average EMA
   ma_smma, // smoothed moving average SMMA
   ma_lwma, // linear weighted moving avregae
   ma_rema  // rsi adaptive ema RMA
};
extern double              FastPeriod   = 14;
extern double              SlowPeriod   = 34;
extern int                 SignalPeriod =  9;
extern enMaMethod          SignalMethod = ma_ema;
extern int                 RsiPeriod    = 14;
extern ENUM_APPLIED_PRICE  Price        = PRICE_CLOSE;

//
//
//
//
//

double macd[];
double macdl[];
double signal[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,macd); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macdl);
   SetIndexBuffer(2,signal);
      IndicatorShortName("MACD rsi adaptive ("+DoubleToStr(FastPeriod,2)+","+DoubleToStr(SlowPeriod,2)+","+SignalPeriod+","+RsiPeriod+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
    
      for(int i = limit; i>=0; i--)
      {
         double rsi   = iRSI(NULL,0,RsiPeriod,Price,i);
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         macd[i]  = iREma(price,FastPeriod,RsiPeriod,rsi,i,0)-iREma(price,SlowPeriod,RsiPeriod,rsi,i,1);
         macdl[i] = macd[i];
      }            
      for(i = limit; i>=0; i--)
         if (SignalMethod==ma_rema)
               signal[i] = iREma(macd[i],SignalPeriod,RsiPeriod,iRSI(NULL,0,RsiPeriod,price,i),i,2);
         else  signal[i] = iMAOnArray(macd,0,SignalPeriod,0,(int)SignalMethod,i);
         
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double ema[][3];
double iREma(double price, int emaPeriod, int rsiPeriod, double rsi, int i, int instanceNo=0)
{
   if (ArrayRange(ema,0)!=Bars) ArrayResize(ema,Bars); int r=Bars-i-1;
   
   //
   //
   //
   //
   //
   
   double RSvoltl = MathAbs(rsi-50)+1.0;
   double multi   = (5.0+100.0/rsiPeriod)/(0.06+0.92*RSvoltl+0.02*MathPow(RSvoltl,2));
   double alpha   = 2.0 /(1.0+multi*emaPeriod);
           ema[r][instanceNo] = ema[r-1][instanceNo]+alpha*(price-ema[r-1][instanceNo]);
   return( ema[r][instanceNo]);           
}