//+------------------------------------------------------------------+
//|                                          colored macd            |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Green
#property indicator_color2     Coral
#property indicator_color3     DarkSlateGray
#property indicator_color4     Aqua
#property indicator_color5     Red
#property indicator_width1     3
#property indicator_width2     3
#property indicator_width3     3
#property indicator_width4     1
#property indicator_width5     1
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern string note1           = "----------------------";
extern string note2           = "Fast Moving Average";
extern int    FastMa          = 12;
extern string note3           = "0=Simple,1=Exponential";
extern string note4           = "2=Smooth,3=Linear Weighted";
extern int    FastMa_Method   = 1;
extern string note5           = "----------------------";
extern string note6           = "Slow Moving Average";
extern int    SlowMa          = 26;
extern string note7           = "0=Simple,1=Exponential";
extern string note8           = "2=Smooth,3=Linear Weighted";
extern int    SlowMa_Method   = 1;
extern string note9           = "----------------------";
extern string note10          = "Signal Moving Average";
extern int    SignalMa        = 9;
extern string note11          = "0=Simple,1=Exponential";
extern string note12          = "2=Smooth,3=Linear Weighted";
extern int    SignalMa_Method = 1;

//
//
//
//
//

double Upa[];
double Dna[];
double osma[];
double macd[];
double signal[];
double trend[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,Upa);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dna);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,osma);
   SetIndexBuffer(3,signal);
   SetIndexBuffer(4,macd);
   SetIndexBuffer(5,trend);
   SetLevelValue(0,0);
   
   FastMa   = MathMax(FastMa,1);
   SlowMa   = MathMax(SlowMa,1);
   SignalMa = MathMax(SignalMa,1);
   
      //
      //
      //
      //
      //
       
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
         calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
          
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+" MACD ["+getAverageName(FastMa_Method)+" ("+FastMa+"),"+getAverageName(SlowMa_Method)+" ("+SlowMa+"),"+getAverageName(SignalMa_Method)+"("+SignalMa+")]");
return(0);
}
            
int deinit() { return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Upa[0] = limit+1; return(0); } 

   //
   //
   //
   //
   //
    
   if (calculateValue || timeFrame == Period())
   {
     for (i=limit; i>=0; i--) macd[i]   = iMA(NULL,0,FastMa,0,FastMa_Method,PRICE_CLOSE,i) - iMA(NULL,0,SlowMa,0,SlowMa_Method,PRICE_CLOSE,i);
     for (i=limit; i>=0; i--) signal[i] = iMAOnArray(macd,Bars,SignalMa,0,SignalMa_Method,i);
     for (i=limit; i>=0; i--) 
     {
        osma[i]  = macd[i]-signal[i];
        Upa[i]   = EMPTY_VALUE;
        Dna[i]   = EMPTY_VALUE;
        trend[i] = trend[i+1];
         if (osma[i] > 0)  trend[i] =  1;
         if (osma[i] < 0)  trend[i] = -1;
         if (trend[i]== 1) Upa[i] = osma[i];
         if (trend[i]==-1) Dna[i] = osma[i];
    }     
   return(0);           
   }

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);               
          Upa[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","","",FastMa,"","",FastMa_Method,"","",SlowMa,"","",SlowMa_Method,"","",SignalMa,"","",SignalMa_Method,0,y);
          Dna[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","","",FastMa,"","",FastMa_Method,"","",SlowMa,"","",SlowMa_Method,"","",SignalMa,"","",SignalMa_Method,1,y);
          osma[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","","",FastMa,"","",FastMa_Method,"","",SlowMa,"","",SlowMa_Method,"","",SignalMa,"","",SignalMa_Method,2,y);
          signal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","","",FastMa,"","",FastMa_Method,"","",SlowMa,"","",SlowMa_Method,"","",SignalMa,"","",SignalMa_Method,3,y);
          macd[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue","","",FastMa,"","",FastMa_Method,"","",SlowMa,"","",SlowMa_Method,"","",SignalMa,"","",SignalMa_Method,4,y);
   }
return(0);
         
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

string methodNames[] = { "SMA","EMA","SSMA","LWMA" };
string getAverageName(int& method)
{
   int max = ArraySize(methodNames)-1;
      method=MathMax(MathMin(method,max),0); return(methodNames[method]);
}


