//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     DodgerBlue
#property indicator_color2     Blue
#property indicator_color3     Crimson
#property indicator_color4     LightSalmon
#property indicator_color5     White
#property indicator_color6     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_width5     1
#property indicator_width6     2
#property indicator_level1     0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int  FastEMA          = 12;
extern int  SlowEMA          = 24;
extern int  SignalSMA        = 9;
extern int  Histo_Size       = 3;//1=Standard Lines & Histo
extern bool Show_MACDLine    = true; 
extern bool Show_MACDSigLine = true;

//
//
//
//
//

double macd[];
double sign[];
double osma[];
double osmahuu[];
double osmahud[];
double osmahdd[];
double osmahdu[];
double slope[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,osmahuu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,osmahud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,osmahdd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,osmahdu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd);
   SetIndexBuffer(5,sign);
   SetIndexBuffer(6,osma);
   SetIndexBuffer(7,slope);
   if (Show_MACDLine)
   {
     SetIndexStyle(4,DRAW_LINE); 
   }
   else
   {
     SetIndexStyle(4,DRAW_NONE);
   }  
   if (Show_MACDSigLine)
   {
     SetIndexStyle(5,DRAW_LINE); 
   }
   else
   {
     SetIndexStyle(5,DRAW_NONE);
   }
   FastEMA   = MathMax(FastEMA,1);
   SlowEMA   = MathMax(SlowEMA,1);
   SignalSMA = MathMax(SignalSMA,1);            
   IndicatorShortName("MACD  ("+FastEMA+","+SlowEMA+","+SignalSMA+")");
return(0);
}

//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
//
//

int start()
{
   int i,limit;
   int counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
             limit=MathMin(Bars-counted_bars,Bars-1);
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) macd[i] = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
   for(i=limit; i>=0; i--) sign[i] = iMAOnArray(macd,0,SignalSMA,0,MODE_EMA,i);
   for(i=limit; i>=0; i--) 
   {
      osma[i]    = (macd[i]-sign[i])*Histo_Size;
      osmahuu[i] = EMPTY_VALUE;
      osmahud[i] = EMPTY_VALUE;
      osmahdd[i] = EMPTY_VALUE;
      osmahdu[i] = EMPTY_VALUE;   
      
      //
      //
      //
      //
      //
                           
      slope[i] = slope[i+1];
         if (osma[i] > osma[i+1]) slope[i] =  1;
         if (osma[i] < osma[i+1]) slope[i] = -1;
         if (osma[i]>0)
         if (slope[i]==1)
               osmahuu[i] = osma[i];
         else  osmahud[i] = osma[i];
         if (osma[i]<0)
         if (slope[i]==-1)
               osmahdu[i] = osma[i];
         else  osmahdd[i] = osma[i];
         
      }  
  return(0);
  }
//+------------------------------------------------------------------+

