//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DimGray
#property indicator_color4  PaleVioletRed
#property indicator_color5  PaleVioletRed
#property indicator_color6  PaleVioletRed
#property indicator_width6  2
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DASHDOTDOT
#property indicator_style4  STYLE_DOT

//
//
//
//
//

extern int    FastEma               = 12;
extern int    SlowEma               = 26;
extern int    Price                 = PRICE_CLOSE;
extern int    DeviationsLength      = 14;
extern double DeviationsMultiplier1 = 1;
extern double DeviationsMultiplier2 = 2;

double macd[];
double zero[];
double bandu1[];
double bandu2[];
double bandd2[];
double bandd1[];

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorDigits(6);
      SetIndexBuffer(0,bandu2);
      SetIndexBuffer(1,bandu1);
      SetIndexBuffer(2,zero);
      SetIndexBuffer(3,bandd1);
      SetIndexBuffer(4,bandd2);
      SetIndexBuffer(5,macd);
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;

   //
   //
   //
   //
   //
   
   for(int i=MathMin(Bars-counted_bars,Bars-1); i>=0; i--)
   {
      macd[i] = iMA(NULL,0,FastEma,0,MODE_EMA,Price,i)-iMA(NULL,0,SlowEma,0,MODE_EMA,Price,i);
      zero[i] = 0; for (int k=0; k<DeviationsLength; k++) zero[i] += macd[i+k]; zero[i] /= DeviationsLength;
            double deviation = iDeviation(macd[i],DeviationsLength,true,i);
                   bandu1[i] = zero[i]+DeviationsMultiplier1*deviation;
                   bandu2[i] = zero[i]+DeviationsMultiplier2*deviation;
                   bandd2[i] = zero[i]-DeviationsMultiplier2*deviation;
                   bandd1[i] = zero[i]-DeviationsMultiplier1*deviation;
   }
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
// 
//
//
//
//

double workDev[];
double iDeviation(double value, int length, bool isSample, int i)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); i=Bars-i-1; workDev[i] = value;
                 
   //
   //
   //
   //
   //
   
      double oldMean   = value;
      double newMean   = value;
      double squares   = 0;
      for (int k=1; k<length && (i-k)>=0; k++)
      {
         newMean  = (workDev[i-k]-oldMean)/(k+1)+oldMean;
         squares += (workDev[i-k]-oldMean)*(workDev[i-k]-newMean);
         oldMean  = newMean;
      }
      return(MathSqrt(squares/MathMax(k-isSample,1)));
}