
//
//
//
//
//

#property  indicator_separate_window
#property  indicator_buffers   4
#property  indicator_color1    LimeGreen
#property  indicator_color2    Red
#property  indicator_color3    Yellow
#property  indicator_color4    DarkSlateGray
#property  indicator_width1    2
#property  indicator_width2    2
#property  indicator_width4    2
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern int                FastMa       = 12;
extern ENUM_MA_METHOD     FastMaMode   = MODE_EMA;
extern ENUM_APPLIED_PRICE FastMaPrice  = PRICE_CLOSE;
extern int                SlowMa       = 26;
extern ENUM_MA_METHOD     SlowMaMode   = MODE_EMA;
extern ENUM_APPLIED_PRICE SlowMaPrice  = PRICE_CLOSE;
extern int                SignalMa     = 9;
extern ENUM_MA_METHOD     SignalMaMode = MODE_SMA;

//
//
//
//
//

double macd[];   
double Up[];   
double Dn[];
double signal[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
  
  IndicatorBuffers(5);
   SetIndexBuffer(0,Up);    SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dn);    SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,signal); 
   SetIndexBuffer(3,macd);
   SetIndexBuffer(4,trend);
      FastMa   = MathMax(FastMa,1);
      SlowMa   = MathMax(SlowMa,1);
      SignalMa = MathMax(SignalMa,1);

      //
      //
      //
      //
      //
   
      IndicatorShortName("Macd_color("+FastMa+","+SlowMa+","+SignalMa+")");
return(0);
}

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) macd[i]   = iMA(NULL,0,FastMa,0,FastMaMode,FastMaPrice,i) - iMA(NULL,0,SlowMa,0,SlowMaMode,SlowMaPrice,i);
   for(i=limit; i>=0; i--) signal[i] = iMAOnArray(macd,0,SignalMa,0,SignalMaMode,i);
   for(i=limit; i>=0; i--)
   { 
      Dn[i]    = EMPTY_VALUE;
      Up[i]    = EMPTY_VALUE;
      trend[i] = trend[i+1];
      
        if (macd[i]>0) trend[i] = 1;
        if (macd[i]<0) trend[i] =-1;
        if (trend[i] == 1) Up[i] = macd[i];  
        if (trend[i] ==-1) Dn[i] = macd[i]; 
   }
return(0);
}
   
   