//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"



#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_width1  4
#property indicator_width2  4

//
//
//
//
//

extern string TimeFrame        = "current time frame";
extern int    FastEmaPeriod    = 12;
extern int    SlowEmaPeriod    = 26;
extern int    SignalPeriod     = 9;

extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double sigUp[];
double sigDn[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,sigUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,sigDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
   
   //
   //
   //
   //
   //
     
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
 

   //
   //
   //
   //
   //
         
   IndicatorShortName(timeFrameToString(timeFrame)+"  Macd Crossover ");
   return(0);
}

int deinit()  {   return(0);  }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { sigUp[0] = limit+1; return(0); }


   //
   //
   //
   //
   //
   if (calculateValue || timeFrame==Period())
   {
     for(i=limit; i>=0; i--)
     {
         double macd = iMACD(NULL,0,FastEmaPeriod,SlowEmaPeriod,SignalPeriod,PRICE_CLOSE,MODE_MAIN  ,i);
         double sign = iMACD(NULL,0,FastEmaPeriod,SlowEmaPeriod,SignalPeriod,PRICE_CLOSE,MODE_SIGNAL,i);

         //
         //
         //
         //
         //
            
         sigUp[i] = EMPTY_VALUE;
         sigDn[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (macd>sign) trend[i] =  1;
            if (macd<sign) trend[i] = -1;
               if (trend[i]== 1) sigUp[i] = 1;
               if (trend[i]==-1) sigDn[i] = 1;
      }
      manageAlerts();
      return(0);
   }            

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         sigUp[i] = EMPTY_VALUE;
         sigDn[i] = EMPTY_VALUE;
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEmaPeriod,SlowEmaPeriod,SignalPeriod,2,y); 
            if (trend[i]== 1) sigUp[i] = 1;
            if (trend[i]==-1) sigDn[i] = 1;
   }
   manageAlerts();    
return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert(whichBar,"up");
         else  doAlert(whichBar,"down");       
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Macd Bar changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Macd Cross "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

