//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"



#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  RoyalBlue
#property indicator_color2  Red
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_width1  4
#property indicator_width2  4

//
//
//
//
//

extern string TimeFrame        = "current time frame";
extern int    FastMa           = 12;
extern int    FastMaMode       = 1; 
extern int    FastMaPrice      = 0; 
extern int    SlowMa           = 26;
extern int    SlowMaMode       = 1; 
extern int    SlowMaPrice      = 0; 
extern int    SignMa           = 9;
extern int    SignMaMode       = 0; 
extern string note1            = "0 =sma, 1 =ema, 2 =smma, 3 =lwma, 4=lsma";

extern bool   alertsOn         = true;
extern bool   ShowText         = False;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

extern int    TextPosition     = 675;
extern color  upTextcolor      = Blue;
extern color  dnTextcolor      = Red;
 

//
//
//
//
//

double sigUp[];
double sigDn[];
double macd[];
double sign[];
double trend[];
string TextDir = "macd cross";

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,sigUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,sigDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macd);
   SetIndexBuffer(3,sign);
   SetIndexBuffer(4,trend);
   
   //
   //
   //
   //
   //
     
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
 

   //
   //
   //
   //
   //
         
   IndicatorShortName(timeFrameToString(timeFrame)+"  Macd Crossover ");
   return(0);
}

int deinit()  
{   
   ObjectDelete(TextDir);
   
return(0);  
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { sigUp[0] = limit+1; return(0); }


   //
   //
   //                                                
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     for (i=limit; i>=0; i--) macd[i] = iMA(NULL,0,FastMa,0,FastMaMode,FastMaPrice,i) - iMA(NULL,0,SlowMa,0,SlowMaMode,SlowMaPrice,i);
     for (i=limit; i>=0; i--) sign[i] = iMAOnArray(macd,0,SignMa,0,SignMaMode,i);
     for (i=limit; i>=0; i--)
     { 
         
         sigUp[i] = EMPTY_VALUE;
         sigDn[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (macd[i]>sign[i]) trend[i] =  1;
            if (macd[i]<sign[i]) trend[i] = -1;
            if (trend[i]== 1) { sigUp[i] = 1; Commenter(1);  }
            if (trend[i]==-1) { sigDn[i] = 1; Commenter(-1); }
      }
      manageAlerts();
      return(0);
   }            

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         sigUp[i] = EMPTY_VALUE;
         sigDn[i] = EMPTY_VALUE;
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,FastMaPrice,SlowMa,SlowMaMode,SlowMaPrice,SignMa,SignMaMode,"",4,y); 
            if (trend[i]== 1) { sigUp[i] = 1; Commenter(1);  }
            if (trend[i]==-1) { sigDn[i] = 1; Commenter(-1); }
   }

manageAlerts();    
return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert(whichBar,"UP");
         else  doAlert(whichBar,"DOWN");       
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //


      message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MACD Bar - ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"MACD Bar"),message);
          if (alertsSound)   PlaySound("alert2.wav");
      }

     
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};


//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

void Commenter(int Dir) 
{
    if (ShowText)
    {
      ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
      ObjectSet(TextDir,OBJPROP_XDISTANCE,TextPosition);
      ObjectSet(TextDir,OBJPROP_YDISTANCE,2);
      if (Dir == 1) ObjectSetText(TextDir,"BUY",12,"Arial Black", upTextcolor);
      if (Dir ==-1) ObjectSetText(TextDir,"SELL",12,"Arial Black",dnTextcolor);
   }
   
return; 
}