//+------------------------------------------------------------------+
//|                                                   MACD Histo.mq4 |
//|                                             by CJA for tsd forum |
//+------------------------------------------------------------------+
#property link      "cja tsd forum"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Chocolate
#property indicator_color2 DarkGreen
#property indicator_color3 Maroon      
#property indicator_color4 Red 
#property indicator_color5 Aqua 

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 1
#property indicator_width5 1

#property indicator_level1 0
#property indicator_levelcolor DarkSlateGray 
#property indicator_levelstyle STYLE_DOT
#property indicator_levelwidth 1

//---- input parameters

extern int       FastEMA      = 8;
extern int       SlowEMA      = 17;
extern int       SignalSMA    = 9;
extern bool      ShowLINES    = true;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];

string indicatorname;
 
int init()
  {
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);
   if(ShowLINES){SetIndexStyle(3,DRAW_LINE);}
   else{SetIndexStyle(3,DRAW_NONE);}
   SetIndexBuffer(3,ExtMapBuffer4);
   if(ShowLINES){SetIndexStyle(4,DRAW_LINE);}
   else{SetIndexStyle(4,DRAW_NONE);}
   SetIndexBuffer(4,ExtMapBuffer5);
  
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");
   SetIndexLabel(4,"");
   
   indicatorname = ("MACD Histo");
   IndicatorShortName(indicatorname); 
//----
   return(0);
  }
int deinit(){ return(0);}

int start()
  {
    int limit;
    int counted_bars = IndicatorCounted();
    if(counted_bars < 0) 
              return(-1);
    if(counted_bars > 0) 
       counted_bars--;
    limit = Bars - counted_bars;
  
    
    for(int i=limit; i>=0; i--)
      {
      
      ExtMapBuffer1[i]=(iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,i) - iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,i));
      
      ExtMapBuffer2[0]=EMPTY_VALUE;
      ExtMapBuffer3[0]=EMPTY_VALUE;
      
      if(ExtMapBuffer1[i] > 0 && ExtMapBuffer1[i]>=ExtMapBuffer1[i+1]){ ExtMapBuffer2[i]= ExtMapBuffer1[i];ExtMapBuffer3[i]=EMPTY_VALUE;}
      if(ExtMapBuffer1[i] < 0 && ExtMapBuffer1[i]<=ExtMapBuffer1[i+1]){ ExtMapBuffer3[i]= ExtMapBuffer1[i];ExtMapBuffer2[i]=EMPTY_VALUE;}
    
      
      ExtMapBuffer4[i]=iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,i);
      ExtMapBuffer5[i]=iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,i);
       } 
     }
   return(0);

