//+------------------------------------------------------------------+
//|                                                MACD Histo v1.mq4 |
//|                                                   cja 2010       |
//+------------------------------------------------------------------+
#property  copyright "cja 2010"
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color5 Gold
#property indicator_width5 2

#property indicator_color1 DodgerBlue
#property indicator_width1 1

#property indicator_color2 Lime
#property indicator_width2 1

#property indicator_color3 Red
#property indicator_width3 1

#property indicator_color4 Gray
#property indicator_width4 1
#property indicator_style4 2


//---- input parameters
extern int MACD_BarsBack  = 100;
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
extern int Maxbars   = 1000;       
          
//---- indicator buffers
double ExtBuffer1[];
double BufferMACD[];
double BufferHI[];
double BufferLO[];
double BufferZero[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexDrawBegin(4,SignalSMA);
   SetIndexBuffer(4,ExtBuffer1);
   SetIndexStyle(4,DRAW_LINE);
  
   SetIndexBuffer(0,BufferMACD);
   SetIndexStyle(0,DRAW_LINE);
   
   SetIndexBuffer(1,BufferHI);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   
   SetIndexBuffer(2,BufferLO);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   
   SetIndexBuffer(3,BufferZero);
   SetIndexStyle(3,DRAW_LINE);
   
  
   
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");
   SetIndexLabel(4,"");
   
   
   
   IndicatorShortName("MACD Histov1 [ "+FastEMA+","+SlowEMA+","+SignalSMA+" ]");
   
      //
 //---- initialization done
   return(0);
  }

//+------------------------------------------------------------------+
//| ema                                                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int limit;
   int i;
    limit = MathMin(counted_bars,Maxbars);
   if (limit ==0)
      limit = Maxbars;
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
  
//---- main loop
 
  double lowestMA=9999, highestMA=-9999;
   
  
   for(i=0; i<limit; i++)
     {   
   
  ExtBuffer1[i]=iMACD(Symbol(),0,FastEMA,SlowEMA,SignalSMA,0,1,i); 
  BufferMACD[i]=iMACD(Symbol(),0,FastEMA,SlowEMA,SignalSMA,0,0,i); 
  
  if(BufferMACD[i]>ExtBuffer1[i]){BufferHI[i]=BufferMACD[i];BufferLO[i]=0;}
  if(BufferMACD[i]<ExtBuffer1[i]){BufferLO[i]=BufferMACD[i];BufferHI[i]=0;}
  
  
  BufferZero[i]=0;
 
  
   }
     
      
//---- done
   return(0);
  }
  
  
//+------------------------------------------------------------------+