//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  C'0,200,0'//LimeGreen
#property indicator_color2  Red//PaleVioletRed
#property indicator_color3  Red//PaleVioletRed
#property indicator_color4  Silver//Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  STYLE_DOT
#property indicator_level1  0
//
#property  indicator_levelcolor Silver
#property  indicator_levelstyle 0
#property  indicator_levelwidth 1
//
//
//
//
//

extern int  FastEMA   = 12;
extern int  SlowEMA   = 26;
extern int  SignalEMA =  9;
extern int  Price     = PRICE_CLOSE;
extern bool ColorOnSignalCross = true;

double macd[];
double macdDa[];
double macdDb[];
double signal[];
double colors[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,macd);
   SetIndexBuffer(1,macdDa);
   SetIndexBuffer(2,macdDb);
   SetIndexBuffer(3,signal);
   SetIndexBuffer(4,colors);
      IndicatorShortName("MACD nrp_csc ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double emas[][2];
int start()
{
   double alphaSign = 2.0/(1.0+SignalEMA);
   double alphaFast = 2.0/(1.0+FastEMA);
   double alphaSlow = 2.0/(1.0+SlowEMA);
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);

   //
   //
   //
   //
   //
   
   if (colors[limit]==-1) CleanPoint(limit,macdDa,macdDb);
   for(i = limit, r=Bars-i-1; i >= 0 ; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      if (i>Bars-2)
      {
         emas[r][0] = price;
         emas[r][1] = price;
         macd[i]    = 0;
         signal[i]  = 0;
         continue;
      }

      emas[r][0] = emas[r-1][0]+alphaFast*(price-emas[r-1][0]);
      emas[r][1] = emas[r-1][1]+alphaSlow*(price-emas[r-1][1]);
      macd[i]    = emas[r][0]-emas[r][1];
      macdDa[i]  = EMPTY_VALUE;
      macdDb[i]  = EMPTY_VALUE;
      signal[i]  = signal[i+1]+alphaSign*(macd[i]-signal[i+1]);
      colors[i]  = colors[i+1];
      if (ColorOnSignalCross)
      {
         if (macd[i]>signal[i]) colors[i] =  1;
         if (macd[i]<signal[i]) colors[i] = -1;
         }
         else
         {
         if (macd[i]>macd[i+1]) colors[i] =  1;
         if (macd[i]<macd[i+1]) colors[i] = -1;
         }
         if (colors[i]==-1) PlotPoint(i,macdDa,macdDb,macd);
   }         
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}