//+------------------------------------------------------------------+
//|                                            MACD_OsMA_ColorLH.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//| mod. Variable MA settings             http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
// 2008forextsd mod2009fxtsd 
//MACD_OsMA_4ColorH_2LVar1.2_mtf.mq4

#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  LimeGreen
#property  indicator_color2  C'0,66,0' //DarkGreen
#property  indicator_color3  C'83,0,0' //Maroon
#property  indicator_color4  Red
#property  indicator_color5  DarkOrange 
#property  indicator_color6  DodgerBlue

#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2
#property  indicator_width4  2
#property  indicator_width5  1
#property  indicator_width6  1

//---- indicator buffers

extern int FastMA_Period=12;
extern int SlowMA_Period=26;
extern int SignalMA_Period=9;

extern int FastMA_Mode=1;
extern int SlowMA_Mode=1;
extern int SignalMA_Mode=0;

extern int FastMA_Price=0;
extern int SlowMA_Price=0;
extern double    OsmaMultiplier  = 1.8;
extern bool ShowOsMA_Histo = true;
extern bool ShowMACD_Histo = false;

extern int TimeFrame = 0;

extern string  note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string  note_AppliedPrice = "0C,1O 2H3L,4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string  note_MA_Mode =  "SMA0 EMA1 SMMA2 LWMA3";
extern string  note_defaults = "AO:34,5;SMA;PriceMedian(4);MACD 12 26 9 EMA Close;SignalLinePrice- Close only(MaOnArray) ";
string         IndicatorFileName;


double     Buffer1hpu[], Buffer2hpd[];
double     Buffer3hnu[], Buffer4hnd[];
double     Buffer5sig[];
double     Buffer6macd[];
double     Buffer7osma[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----  additional buffer used for counting.
   IndicatorBuffers(7);
   //---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);   
  
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);   
   
   IndicatorDigits(Digits+2);
   
   SetIndexDrawBegin(0,SlowMA_Period);
   SetIndexDrawBegin(1,SlowMA_Period);
   SetIndexDrawBegin(2,SlowMA_Period);
   SetIndexDrawBegin(3,SlowMA_Period);

   SetIndexDrawBegin(4,SlowMA_Period);
   SetIndexDrawBegin(5,SlowMA_Period);
   SetIndexDrawBegin(6,SlowMA_Period);

//---- indicator buffers mapping

//---- indicator buffers mapping
   SetIndexBuffer(0,Buffer1hpu);  
   SetIndexBuffer(1,Buffer2hpd); 
   SetIndexBuffer(2,Buffer3hnu); 
   SetIndexBuffer(3,Buffer4hnd); 
   SetIndexBuffer(4,Buffer5sig);  
   SetIndexBuffer(5,Buffer6macd); 
   SetIndexBuffer(6,Buffer7osma);

      TimeFrame = MathMax(TimeFrame,Period());

           switch(TimeFrame)
   {
      case 1: string TimeFrameStr = "M1";  break;
      case 5     :   TimeFrameStr = "M5";  break;
      case 15    :   TimeFrameStr = "M15"; break;
      case 30    :   TimeFrameStr = "M30"; break;
      case 60    :   TimeFrameStr = "H1";  break;
      case 240   :   TimeFrameStr = "H4";  break;
      case 1440  :   TimeFrameStr = "D1";  break;
      case 10080 :   TimeFrameStr = "W1";  break;
      case 43200 :   TimeFrameStr = "MN1"; break;
      default :      TimeFrameStr = "TF0";
   }

//---- name for DataWindow and indicator subwindow label

   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");
   SetIndexLabel(4,"macdSigL");
   SetIndexLabel(5,"MACD");


   IndicatorShortName("MACD_OsMA ["+TimeFrameStr+"] ("+FastMA_Period+","+SlowMA_Period+","+SignalMA_Period+")");

   IndicatorFileName = WindowExpertName();

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
 {
   double prev,current;
   int    i,limit,counted_bars=IndicatorCounted();
//---- last counted bar will be recounted

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;

   limit= Bars-counted_bars;
   if (TimeFrame != Period())
      {
         limit = MathMax(limit,TimeFrame/Period());
         datetime TimeArray[];
         ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
            for(i=0,int y=0; i<limit; i++)
            {
               if(Time[i]<TimeArray[y]) y++;
              
    Buffer1hpu[i] = iCustom(NULL,TimeFrame,IndicatorFileName,FastMA_Period,SlowMA_Period,
                        SignalMA_Period,FastMA_Mode,SlowMA_Mode,SignalMA_Mode,FastMA_Price,
                        SlowMA_Price,OsmaMultiplier,ShowOsMA_Histo,ShowMACD_Histo,0,y);
    Buffer2hpd[i]= iCustom(NULL,TimeFrame,IndicatorFileName,FastMA_Period,SlowMA_Period,
                        SignalMA_Period,FastMA_Mode,SlowMA_Mode,SignalMA_Mode,FastMA_Price,
                        SlowMA_Price,OsmaMultiplier,ShowOsMA_Histo,ShowMACD_Histo,1,y);
    Buffer3hnu[i] = iCustom(NULL,TimeFrame,IndicatorFileName,FastMA_Period,SlowMA_Period,
                        SignalMA_Period,FastMA_Mode,SlowMA_Mode,SignalMA_Mode,FastMA_Price,
                        SlowMA_Price,OsmaMultiplier,ShowOsMA_Histo,ShowMACD_Histo,2,y);
    Buffer4hnd[i]= iCustom(NULL,TimeFrame,IndicatorFileName,FastMA_Period,SlowMA_Period,
                        SignalMA_Period,FastMA_Mode,SlowMA_Mode,SignalMA_Mode,FastMA_Price,
                        SlowMA_Price,OsmaMultiplier,ShowOsMA_Histo,ShowMACD_Histo,3,y);
    Buffer5sig[i] = iCustom(NULL,TimeFrame,IndicatorFileName,FastMA_Period,SlowMA_Period,
                        SignalMA_Period,FastMA_Mode,SlowMA_Mode,SignalMA_Mode,FastMA_Price,
                        SlowMA_Price,OsmaMultiplier,ShowOsMA_Histo,ShowMACD_Histo,4,y);
    Buffer6macd[i] = iCustom(NULL,TimeFrame,IndicatorFileName,FastMA_Period,SlowMA_Period,
                        SignalMA_Period,FastMA_Mode,SlowMA_Mode,SignalMA_Mode,FastMA_Price,
                        SlowMA_Price,OsmaMultiplier,ShowOsMA_Histo,ShowMACD_Histo,5,y);
    Buffer7osma[i] = iCustom(NULL,TimeFrame,IndicatorFileName,FastMA_Period,SlowMA_Period,
                        SignalMA_Period,FastMA_Mode,SlowMA_Mode,SignalMA_Mode,FastMA_Price,
                        SlowMA_Price,OsmaMultiplier,ShowOsMA_Histo,ShowMACD_Histo,6,y);
         
            }
         return(0);         
      }


   for(i=limit; i>=0; i--)

     Buffer6macd[i]=iMA(NULL,TimeFrame,FastMA_Period,0,FastMA_Mode,FastMA_Price,i)-
                    iMA(NULL,TimeFrame,SlowMA_Period,0,SlowMA_Mode,SlowMA_Price,i);

   for(i=limit; i>=0; i--)
      {
      Buffer5sig[i]=iMAOnArray(Buffer6macd,0,SignalMA_Period,0,SignalMA_Mode,i);
    
      Buffer7osma[i]= (Buffer6macd[i]- Buffer5sig[i])*OsmaMultiplier;

//---- 
 

            Buffer1hpu[i] =0.0;            Buffer2hpd[i]=0.0;             
            Buffer3hnu[i] =0.0;            Buffer4hnd[i]=0.0;


   if (ShowMACD_Histo)
      {
      current=Buffer6macd[i];
      prev   =Buffer6macd[i+1];
      }
   if (ShowOsMA_Histo)
      {
      current=Buffer7osma[i];
      prev   =Buffer7osma[i+1];
      }

      
            Buffer1hpu[i]=0.0;         Buffer3hnu[i]=0.0;             
            Buffer2hpd[i]=0.0;         Buffer4hnd[i]=0.0;

      
      if(current>prev)
        {

            Buffer2hpd[i]=0.0;         Buffer4hnd[i]=0.0;


            if(current > 0)
            {
            Buffer1hpu[i]=current;     Buffer3hnu[i]=0.0;             
            }        
            else
            {
            Buffer1hpu[i] =0.0;        Buffer3hnu[i]=current;           
            }             
         
         }
        
        else 
        if(current<prev)

         {
            Buffer1hpu[i] =0.0;           Buffer3hnu[i] =0.0;            
               
            if(current > 0)
            {
            Buffer2hpd[i] =current;       Buffer4hnd[i] =0.0;
            }
            else
            {
            Buffer2hpd[i] =0.0;           Buffer4hnd[i]= current;
            }           

         }    
            
         else
         {
            Buffer1hpu[i] =Buffer1hpu[i+1];  Buffer2hpd[i]=Buffer2hpd[i+1];             
            Buffer3hnu[i] =Buffer3hnu[i+1];  Buffer4hnd[i]=Buffer4hnd[i+1];
         }           


    }  




//---- done
   return(0);
 }

