
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers    7
#property  indicator_color1     LimeGreen
#property  indicator_color2     C'0,66,0' //DarkGreen
#property  indicator_color3     Red
#property  indicator_color4     C'83,0,0' //Maroon
#property  indicator_color5     DarkGray
#property  indicator_color6     DodgerBlue
#property  indicator_color7     DarkOrange
#property  indicator_width1     2
#property  indicator_width2     2
#property  indicator_width3     2
#property  indicator_width4     2
#property  indicator_width5     1
#property  indicator_width6     1
#property  indicator_width7     1
#property  indicator_level1     0.0
#property  indicator_levelcolor Gold

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    FastMaPeriod     = 12;
extern int    FastMaMode       = 1;
extern int    FastMaPrice      = 0;
extern int    SlowMaPeriod     = 26;
extern int    SlowMaMode       = 1;
extern int    SlowMaPrice      = 0;
extern int    SignalMaPeriod   = 9;
extern int    SignalMaMode     = 1;
extern int    OsmaMultiplier   = 2;
extern bool   HistogramOnSlope = true;

extern bool   alertsOn         = true;
extern bool   alertsOnSlope    = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double osma[];
double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double macd[];
double sig[];
double trend[];
double slope[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,buffer1);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4);   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,osma);
   SetIndexBuffer(5,macd);
   SetIndexBuffer(6,sig);
   
   //
   //
   //
   //
   //
   
     FastMaPeriod   = MathMax(FastMaPeriod,1);
     SlowMaPeriod   = MathMax(SlowMaPeriod,1);
     SignalMaPeriod = MathMax(SignalMaPeriod,1); 
     indicatorFileName = WindowExpertName();
     calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
     returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+"  Macd_Osma ("+FastMaPeriod+","+SlowMaPeriod+","+SignalMaPeriod+")");
   return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int start()
  {
   
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { buffer1[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
  
      
   
   if (calculateValue || timeFrame == Period())
   {
     if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
     if (ArrayRange(slope,0)!=Bars) ArrayResize(slope,Bars);   
     for(i=limit, r=Bars-i-1; i>=0; i--,r++) macd[i] = iMA(NULL,0,FastMaPeriod,0,FastMaMode,FastMaPrice,i)-iMA(NULL,0,SlowMaPeriod,0,SlowMaMode,SlowMaPrice,i);
     for(i=limit, r=Bars-i-1; i>=0; i--,r++)
         if (SignalMaMode==4)
               sig[i] = iHull(macd[i],SignalMaPeriod,i);
         else  sig[i] = iMAOnArray(macd,Bars,SignalMaPeriod,0,SignalMaMode,i);
     for(i=limit, r=Bars-i-1; i>=0; i--,r++)
     { 
        if (OsmaMultiplier<=0)OsmaMultiplier=1;  
        osma[i]   = (macd[i]-sig[i])*OsmaMultiplier;
        buffer1[i]=EMPTY_VALUE;        
        buffer2[i]=EMPTY_VALUE;       
        buffer3[i]=EMPTY_VALUE;       
        buffer4[i]=EMPTY_VALUE;     
        trend[r]  = trend[r-1];
        slope[r]  = slope[r-1];
        
        if (osma[i] > 0)         trend[r] =  1;
        if (osma[i] < 0)         trend[r] = -1;
        if (osma[i] > osma[i+1]) slope[r] =  1;
        if (osma[i] < osma[i+1]) slope[r] = -1;
            
        if (HistogramOnSlope)
        {
          if (trend[r] ==  1 && slope[r] ==  1) buffer1[i] = osma[i];
          if (trend[r] ==  1 && slope[r] == -1) buffer2[i] = osma[i];
          if (trend[r] == -1 && slope[r] == -1) buffer3[i] = osma[i];
          if (trend[r] == -1 && slope[r] ==  1) buffer4[i] = osma[i];
        }
        else
        {                  
          if (trend[r] ==  1) buffer1[i] = osma[i];
          if (trend[r] == -1) buffer3[i] = osma[i];
        }
   }
   manageAlerts();
   return(0);
   } 
        
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
             
          if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
          if (ArrayRange(slope,0)!=Bars) ArrayResize(slope,Bars);   
          for (i=limit, r=Bars-i-1; i>=0; i--,r++)
          { 
             int y = iBarShift(NULL,timeFrame,Time[i]);
                osma[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMaPeriod,FastMaMode,FastMaPrice,SlowMaPeriod,SlowMaMode,SlowMaPrice,SignalMaPeriod,SignalMaMode,OsmaMultiplier,HistogramOnSlope,4,y);
                macd[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMaPeriod,FastMaMode,FastMaPrice,SlowMaPeriod,SlowMaMode,SlowMaPrice,SignalMaPeriod,SignalMaMode,OsmaMultiplier,HistogramOnSlope,5,y);
                sig[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMaPeriod,FastMaMode,FastMaPrice,SlowMaPeriod,SlowMaMode,SlowMaPrice,SignalMaPeriod,SignalMaMode,OsmaMultiplier,HistogramOnSlope,6,y);
                buffer1[i] = EMPTY_VALUE;
                buffer2[i] = EMPTY_VALUE;
                buffer3[i] = EMPTY_VALUE;
                buffer4[i] = EMPTY_VALUE;
                trend[r]  = trend[r-1];
                slope[r]  = slope[r-1];
        
                if (osma[i] > 0)         trend[r] =  1;
                if (osma[i] < 0)         trend[r] = -1;
                if (osma[i] > osma[i+1]) slope[r] =  1;
                if (osma[i] < osma[i+1]) slope[r] = -1;
            
                if (HistogramOnSlope)
                {
                  if (trend[r] ==  1 && slope[r] ==  1) buffer1[i] = osma[i];
                  if (trend[r] ==  1 && slope[r] == -1) buffer2[i] = osma[i];
                  if (trend[r] == -1 && slope[r] == -1) buffer3[i] = osma[i];
                  if (trend[r] == -1 && slope[r] ==  1) buffer4[i] = osma[i];
                }
                else
                {                  
                  if (trend[r] ==  1) buffer1[i] = osma[i];
                  if (trend[r] == -1) buffer3[i] = osma[i];
                }
   }
 manageAlerts();
 return(0);
 } 


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workHull[][2];
double iHull(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workHull,0)!= Bars) ArrayResize(workHull,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //

      int HmaPeriod  = MathMax(period,2);
      int HalfPeriod = MathFloor(HmaPeriod/2);
      int HullPeriod = MathFloor(MathSqrt(HmaPeriod));
      double hma,hmw,weight; instanceNo *= 2;

         workHull[r][instanceNo] = price;

         //
         //
         //
         //
         //
               
         hmw = HalfPeriod; hma = hmw*price; 
            for(int k=1; k<HalfPeriod && (r-k)>=0; k++)
            {
               weight = HalfPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];  
            }             
            workHull[r][instanceNo+1] = 2.0*hma/hmw;

         hmw = HmaPeriod; hma = hmw*price; 
            for(k=1; k<period && (r-k)>=0; k++)
            {
               weight = HmaPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];
            }             
            workHull[r][instanceNo+1] -= hma/hmw;

         //
         //
         //
         //
         //
         
         hmw = HullPeriod; hma = hmw*workHull[r][instanceNo+1];
            for(k=1; k<HullPeriod && (r-k)>=0; k++)
            {
               weight = HullPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][1+instanceNo];  
            }
   return(hma/hmw);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar))-1;
      
      //
      //
      //
      //
      //
      
      if (alertsOnSlope)
      {
         if (slope[whichBar] != slope[whichBar-1])
         {
            if (slope[whichBar] == 1) doAlert(whichBar,"slope changed to up");
            if (slope[whichBar] ==-1) doAlert(whichBar,"slope changed to down");
         }         
      }
      else
      {
         if (trend[whichBar] != trend[whichBar-1])
         {
            if (trend[whichBar] == 1) doAlert(whichBar,"crossed zero line up");
            if (trend[whichBar] ==-1) doAlert(whichBar,"crossed zero line down");
         }         
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Macd_Osma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Macd_Osma "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}     