//+------------------------------------------------------------------+
//|                                         MACD_ColorHist_Alert.mq4 |
//|                                    Copyright  2006, Robert Hill |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2006, Robert Hill"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
//#property  indicator_color1  Aqua
//#property  indicator_color2  Yellow
#property  indicator_color1  Lime
#property  indicator_color2  Red
#property  indicator_color3  DarkGreen
#property  indicator_color4  Maroon

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
//#property indicator_width5 2
//#property indicator_width6 2


//---- indicator parameters



extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
extern int AppliedPrice   = PRICE_CLOSE;


extern int OsmaMultiplier=2;

extern bool SoundON=true;
extern bool EmailON=false;
extern bool OsmaZeroLineCrossAlert=true;
extern bool OsmaDirChangeUpDnAlert=true;

//---- indicator buffers
//double     ind_buffer1[];
double     ind_buffer2[];


double HistogramBufferUp[];
double HistogramBufferDown[];

double HistogramBufferUp1[];
double HistogramBufferDown1[];

int flagval1 = 0;
int flagval2 = 0;
int flagval11 = 0;
int flagval21 = 0;

//---- variables

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorBuffers(5);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
//   SetIndexStyle(0,DRAW_LINE);
//   SetIndexBuffer(0,ind_buffer1);
//   SetIndexDrawBegin(0,SlowEMA);
//   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(4,ind_buffer2);
 //  SetIndexDrawBegin(4,SignalSMA);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,HistogramBufferUp);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,HistogramBufferDown);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,HistogramBufferUp1);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,HistogramBufferDown1);



//   SetIndexDrawBegin(2,SlowEMA + SignalSMA);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("OsMA("+FastEMA+","+SlowEMA+","+SignalSMA+")("+OsmaMultiplier+")");
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");
  
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   double temp,temp1;
   
   int i,counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

//---- macd counted in the 1-st buffer
//   for(i=0; i<limit; i++)
//      ind_buffer1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);

//---- signal line counted in the 2-nd buffer

   for(i=0; i<limit; i++)
    {
//      ind_buffer2[i]=iMAOnArray(ind_buffer1,Bars,SignalSMA,0,MODE_SMA,i);
//      ind_buffer2[i] = alpha*ind_buffer1[i] + alpha_1*ind_buffer2[i+1];
       if (OsmaMultiplier<=0)OsmaMultiplier=1;

        ind_buffer2[i]=iOsMA(NULL,0,FastEMA,SlowEMA,SignalSMA,AppliedPrice,i)*OsmaMultiplier;
    }
   for(i=0; i<limit; i++)
   {
      HistogramBufferUp[i]    = 0.0;
      HistogramBufferDown[i]  = 0.0;
      HistogramBufferUp1[i]   = 0.0;
      HistogramBufferDown1[i] = 0.0;
       

      temp = ind_buffer2[i];
      temp1 =ind_buffer2[i+1];
      
//      temp = (ind_buffer1[i] - ind_buffer2[i])*OsmaMultiplier;
//      temp1 = (ind_buffer1[i+1] - ind_buffer2[i+1])*OsmaMultiplier;
    
     if (temp >0) 
       {
        if (temp-temp1>0)
          {       
          HistogramBufferUp[i] = temp;
          }
          else
          { 
          HistogramBufferUp1[i] = temp;
          HistogramBufferUp [i] = 0.0;
          }
       }    
      else
       {  
         if (temp-temp1>0)
          {       
        HistogramBufferDown[i] = temp; 
          }  
        else 
           {
        HistogramBufferDown1[i] = temp;   
        HistogramBufferDown[i] = 0.0;
           }
      } 
     
      if (i == 1)
      {
//--
        if (HistogramBufferUp[i] > 0 && HistogramBufferDown1[i + 1] < 0)
//        if (HistogramBufferUp[i] >  HistogramBufferUp[i + 1])
         {
// Cross up
         if (flagval1==0)
           {
           flagval1=1;
           flagval2=0;
           if ((SoundON)&&(OsmaZeroLineCrossAlert)) Alert ("Osma CrossedZero Up! ",Symbol()," TF M",Period()," @ ",Bid); 
                if ((EmailON)&&(OsmaZeroLineCrossAlert)) SendMail("Osma CrossedZero up", "Osma CrossedZero up, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
           }
         }
        else if (HistogramBufferDown[i] < 0 && HistogramBufferUp[i + 1] > 0)
//        else if (HistogramBufferUp[i] <  HistogramBufferUp[i + 1] )
        {
// Cross down
         if (flagval2==0)
         {
          flagval2=1;
          flagval1=0;
          if ((SoundON)&&(OsmaZeroLineCrossAlert)) Alert ("Osma CrossZero Down! " ,Symbol()," TF M",Period()," @ ",Bid); 
               if ((EmailON)&&(OsmaZeroLineCrossAlert)) SendMail("Osma Crossed Zero down","Osma CrossedZero Down, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
         }
        }
//


       else if (HistogramBufferUp[i+ 1] >  HistogramBufferUp1[i])
         {
// dn
         if (flagval11==0)
           {
           flagval11=1;
           flagval21=0;
           if ((SoundON)&&(OsmaZeroLineCrossAlert)) Alert ("Osma going Down! ",Symbol()," TF M",Period()," @ ",Bid); 
                if ((EmailON)&&(OsmaZeroLineCrossAlert)) SendMail("Osma going Down", "Osma going Down, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
           }
         }
//

       else if (HistogramBufferDown[i] >  HistogramBufferDown1[i+ 1])
         {
// up
         if (flagval21==0)
           {
           flagval11=0;
           flagval21=1;
           if ((SoundON)&&(OsmaZeroLineCrossAlert)) Alert ("Osma going Up! ",Symbol()," TF M",Period()," @ ",Bid); 
                if ((EmailON)&&(OsmaZeroLineCrossAlert)) SendMail("Osma going Up", "Osma going Up, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
           }
         }


//

      }
      
   }
      
//---- done
   return(0);
  }