//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright ? 2004, MetaQuotes Software Corp. |
//|                                      |
//+------------------------------------------------------------------+
#property  copyright "Copyright ? 2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 1
#property  indicator_color1  Silver

#property  indicator_width1  2

//---- indicator parameters
extern ENUM_TIMEFRAMES  timeFrame = PERIOD_CURRENT;
extern double FastEMA   = 12;
extern double SlowEMA   = 26;
extern double SignalEMA = 9;
extern ENUM_APPLIED_PRICE PriceToCross = PRICE_CLOSE;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsPush      = false;
//---- indicator buffers

double Price[];
double cross[];
double predict[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorBuffers(2);   
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT);
   SetIndexDrawBegin(0,FastEMA);

//---- indicator buffers mapping
   SetIndexBuffer(0,Price);
   SetIndexBuffer(1,cross);
 
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   SetIndexLabel(0,"MACD Predictor");

//---- initialization done
   return(0);
  }
int deinit()
{
   ObjectDelete("signal1");
   
return(0);
}
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   double v1minus2divsgEMAplus1 = 1.0 - 2.0 / (SignalEMA + 1.0);
   double v1minus2divSEMAplus1  = 1.0 - 2.0 / (SlowEMA + 1.0);
   double v1minus2divFEMAplus1  = 1.0 - 2.0 / (FastEMA + 1.0);
   double FEMAmSEMAt2           = 2 * (FastEMA - SlowEMA);
   double FEMAp1tSEMAp1         = (FastEMA + 1.0)*(SlowEMA + 1.0);
   
   int counted_bars=IndicatorCounted();
   int limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
   
   //
   //
   //
   //
   //
   
   
   
      
      
      for (int i=limit;i>=0;i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
         double tpredict =(-1.0) / (FEMAmSEMAt2 * v1minus2divsgEMAplus1) * FEMAp1tSEMAp1 * ((-v1minus2divsgEMAplus1)*(iMA(NULL,0,        FastEMA,0,1,PRICE_CLOSE,0)   * v1minus2divFEMAplus1 - iMA(NULL,0,        SlowEMA,0,1,PRICE_CLOSE,0)   * v1minus2divSEMAplus1 ));// + iCustom(NULL,0,"DiNapoli MACD",FastEMA,SlowEMA,SignalEMA,false,0,0) * v1minus2divsgEMAplus1);
                Price[i] =(-1.0) / (FEMAmSEMAt2 * v1minus2divsgEMAplus1) * FEMAp1tSEMAp1 * ((-v1minus2divsgEMAplus1)*(iMA(NULL,timeFrame,FastEMA,0,1,PRICE_CLOSE,y+1) * v1minus2divFEMAplus1 - iMA(NULL,timeFrame,SlowEMA,0,1,PRICE_CLOSE,y+1) * v1minus2divSEMAplus1 ));// + iCustom(NULL,0,"DiNapoli MACD",FastEMA,SlowEMA,SignalEMA,false,0,i+1) * v1minus2divsgEMAplus1);
         double price    = iMA(NULL,0,1,0,MODE_SMA,PriceToCross,i);
         cross[i] = cross[i+1];
            if (Price[i]>price) cross[i] =  1;
            if (Price[i]<price) cross[i] = -1;
      //double predict=(-1.0)*1.0/((FastEMA-SlowEMA)*2*(1.0-2.0/(SignalEMA+1.0)))* (FastEMA+1.0)*(SlowEMA+1.0)*((2.0/(SignalEMA+1.0)-1.0)*(iMA(NULL,0,FastEMA,0,1,PRICE_CLOSE,0)*(1.0-2.0/(FastEMA+1.0))-iMA(NULL,0,SlowEMA,0,1,PRICE_CLOSE,0)*(1.0-2.0/(SlowEMA+1.0)))+iCustom(NULL,0,"DiNapoli MACD",FastEMA,SlowEMA,SignalEMA,false,0,0)*(1-2.0/(SignalEMA+1.0)));

    datetime futureBarTime  = Time[i]+timeFrame*60;  
    datetime futureBarTime1 = Time[i];  
 
      ObjectCreate("signal1",OBJ_TREND,0,Time[i],Price[i],futureBarTime,tpredict);
         ObjectSet("signal1",OBJPROP_COLOR,Gold);
         ObjectSet("signal1",OBJPROP_RAY,false);
         ObjectSet("signal1",OBJPROP_STYLE,STYLE_DASH);
         double predict1=ObjectGet("signal1",OBJPROP_PRICE1);
      
    if(predict1<tpredict||predict1>tpredict)
    {
      ObjectDelete("signal1");
      
      ObjectCreate("signal1",OBJ_TREND,0,Time[i],Price[i],futureBarTime,tpredict);
         ObjectSet("signal1",OBJPROP_COLOR,Gold);
         ObjectSet("signal1",OBJPROP_RAY,false);
         ObjectSet("signal1",OBJPROP_STYLE,STYLE_DASH);
         predict1=ObjectGet("signal1",OBJPROP_PRICE1);}

   }
   manageAlerts();
   return(0);
   
  }
//+------------------------------------------------------------------+
//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (cross[whichBar] != cross[whichBar+1])
      {
         if (cross[whichBar] ==  1) doAlert("up");
         if (cross[whichBar] == -1) doAlert("down");
      }
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" MACD predictor crossed price "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" MACD predictor",message);
          if (alertsPush)    SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}