#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 Gold
#property indicator_color4 LimeGreen
#property indicator_color5 Red
#property indicator_color6 Gold
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_maximum 2
#property indicator_minimum 0
//
//
//
//
//

extern double FastEma1   = 12;
extern double SlowEma1   = 26;
extern double SignalEma1 =  1;
extern int    Price1     = PRICE_CLOSE;
extern double FastEma2   = 22;
extern double SlowEma2   = 30;
extern double SignalEma2 =  1;
extern int    Price2     = PRICE_CLOSE;
extern bool   ShowOsma  = false;

double histUp1[];
double histDn1[];
double histNe1[];
double histUp2[];
double histDn2[];
double histNe2[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,histUp2); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histDn2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,histNe2); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,histUp1); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,histDn1); SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,histNe1); SetIndexStyle(5,DRAW_HISTOGRAM);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][16];
#define _fastEma 0
#define _slowEma 1
#define _signEma 2
#define _hist    3
#define _trend   4
#define _state   5
#define _currmx  6
#define _currmn  7

int start() 
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         
         
         //
         //
         //
         //
         //
         

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      for (int k =0; k<2; k++)
      {
         int s=k*8;
         if (k==0)
         {
            double alphaF = 2.0/(1.0+FastEma1);
            double alphaS = 2.0/(1.0+SlowEma1);
            double alphaI = 2.0/(1.0+SignalEma1);
            double price  = iMA(NULL,0,1,0,MODE_SMA,Price1,i);
         }            
         else
         {
            alphaF = 2.0/(1.0+FastEma2);
            alphaS = 2.0/(1.0+SlowEma2);
            alphaI = 2.0/(1.0+SignalEma2);
            price  = iMA(NULL,0,1,0,MODE_SMA,Price2,i);
         }
         
         //
         //
         //
         //
         //
         
         work[r][s+_fastEma] = work[r-1][s+_fastEma]+alphaF*(price-work[r-1][s+_fastEma]);
         work[r][s+_slowEma] = work[r-1][s+_slowEma]+alphaS*(price-work[r-1][s+_slowEma]);
         double macd = work[r][s+_fastEma]-work[r][s+_slowEma];
            if (ShowOsma)
            {
               work[r][s+_signEma] = work[r-1][s+_signEma]+alphaI*(macd -work[r-1][s+_signEma]);
               work[r][s+_hist]    = macd-work[r][s+_signEma];
            }               
            else work[r][s+_hist]   = macd;   
                 work[r][s+_trend]  = work[r-1][s+_trend];
                 work[r][s+_currmx] = work[r-1][s+_currmx];
                 work[r][s+_currmn] = work[r-1][s+_currmn];
                 work[r][s+_state]  = 0;
                     if (work[r][s+_hist]>0) { work[r][s+_trend] =  1; work[r][s+_currmn] = 0; if (work[r][s+_hist]>work[r][s+_currmx]) { work[r][s+_currmx]=work[r][s+_hist]; work[r][s+_state]= 1; }}
                     if (work[r][s+_hist]<0) { work[r][s+_trend] = -1; work[r][s+_currmx] = 0; if (work[r][s+_hist]<work[r][s+_currmn]) { work[r][s+_currmn]=work[r][s+_hist]; work[r][s+_state]=-1; }}
      
            //
            //
            //
            //
            //
         
            if (k==0)
            {
               histUp1[i] = EMPTY_VALUE;
               histDn1[i] = EMPTY_VALUE;
               histNe1[i] = EMPTY_VALUE;
                  if (work[r][s+_state]==-1) histDn1[i] = 1;
                  if (work[r][s+_state]== 1) histUp1[i] = 1;
                  if (work[r][s+_state]== 0) histNe1[i] = 1;
            }                  
            else
            {
               histUp2[i] = EMPTY_VALUE;
               histDn2[i] = EMPTY_VALUE;
               histNe2[i] = EMPTY_VALUE;
                  if (work[r][s+_state]==-1) histDn2[i] = 2;
                  if (work[r][s+_state]== 1) histUp2[i] = 2;
                  if (work[r][s+_state]== 0) histNe2[i] = 2;
            }
         }            
   }
   return(0);
}