//+------------------------------------------------------------------+
//| MACD_StDevLv_Var                                        MACD.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net  |  
//+------------------------------------------------------------------+
//2008forextsd      ki
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 FireBrick
#property indicator_color2 Maroon
#property indicator_color3 YellowGreen
#property indicator_color4 Green

//---- input parameters

extern int FastMA_Period=12;     // 5  |12 Standart | 8 CJA Settings | 5 Valeo 
extern int SlowMA_Period=26;     // 35 |26          | 17             | 8
extern int SignalMA_Period=9;    // 5  |9           | 9              | 5

extern int FastMA_Mode=1;
extern int SlowMA_Mode=1;
extern int SignalMA_Mode=0;

extern int FastMA_Price=0;
extern int SlowMA_Price=0;


extern double Deviation = 1.62;
extern int StDevPeriod=20;
extern int StDevMethod=0;
extern int StDevPrice=0;

extern bool StDevMacd         = false;
extern bool UseMacdSigL       = true;

//extern int Minutes=0;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];


string TimeFrameStr;

double MACD_Main;
double MACD_Signal;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexBuffer(2,ExtMapBuffer3);
  SetIndexBuffer(3,ExtMapBuffer4);
 
  SetIndexStyle(0,DRAW_LINE);
  SetIndexStyle(1,DRAW_LINE);
  SetIndexStyle(2,DRAW_LINE);
  SetIndexStyle(3,DRAW_LINE);
  

IndicatorShortName("MACD_StDeV ("+FastMA_Period+","+SlowMA_Period+","+SignalMA_Period+") ("+DoubleToStr(Deviation,3)+"): ");

   SetIndexLabel(0,"StDevUpLv");
   SetIndexLabel(1,"StDevDnLv");
   SetIndexLabel(2,"MACDSig");
   SetIndexLabel(3,"MACD");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars;
   
   
   for (i=limit; i>=0; i--)
     {
  ExtMapBuffer4[i]  = iMA(NULL,0,FastMA_Period,0,FastMA_Mode,FastMA_Price,i)-
                      iMA(NULL,0,SlowMA_Period,0,SlowMA_Mode,SlowMA_Price,i);
      }
   
   
   for (i=limit; i>=0; i--)
     {
  ExtMapBuffer3[i] =iMAOnArray(ExtMapBuffer4,0,SignalMA_Period,0,SignalMA_Mode,i);

      }
   
   
   for (i=limit; i>=0; i--)
     {

      if (UseMacdSigL)  double   Macd=ExtMapBuffer3[i];
      else                       Macd=ExtMapBuffer4[i];

   double std=Deviation*iStdDevOnArray(ExtMapBuffer3,0,StDevPeriod,0,StDevMethod,i);                 

      if (StDevMacd)
          {
          ExtMapBuffer1[i]=Macd+std;
          ExtMapBuffer2[i]=Macd-std;
          }    
      else     
          {
          ExtMapBuffer1[i]=+std;
          ExtMapBuffer2[i]=-std;
          }
     
   }  
  return(0);
 }
//+-------------------------------------------------------+