//+------------------------------------------------------------------+
//| MACD_StDvL_basic                                        MACD.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net  |  
//+------------------------------------------------------------------+
//2008 fxtsd        ki
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 FireBrick
#property indicator_color2 Maroon
#property indicator_color3 YellowGreen
#property indicator_color4 Green

//---- input parameters
extern int MACD_Fast = 8;     // 5 AO |12 Standart | 8 CJA Settings | 5 Valeo  
extern int MACD_Slow = 17;    // 35   |26          | 17             | 8
extern int MACD_SigMA = 9;    // 5    |9           | 9              | 5


extern double Deviation = 1.62;
extern int StDevPeriod=20;
extern int StDevMethod=0;
extern int StDevPrice=0;


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {

  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexBuffer(2,ExtMapBuffer3);
  SetIndexBuffer(3,ExtMapBuffer4);
 
  SetIndexStyle(0,DRAW_LINE);
  SetIndexStyle(1,DRAW_LINE);
  SetIndexStyle(2,DRAW_LINE);
  SetIndexStyle(3,DRAW_LINE);

 IndicatorShortName("MACD_StDv ("+MACD_Fast+","+MACD_Slow+","+MACD_SigMA+") ("+DoubleToStr(Deviation,3)+") ");  

   SetIndexLabel(0,"StDevUpLv");
   SetIndexLabel(1,"StDevDnLv");
   SetIndexLabel(2,"MACDSig");
   SetIndexLabel(3,"MACD");

   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
 
   int    i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
 
 
 
   
   for (i=limit; i>=0; i--)
   {

  ExtMapBuffer4[i]  = iMACD(NULL,0,MACD_Fast,MACD_Slow,MACD_SigMA,0,MODE_MAIN,i);
  ExtMapBuffer3[i]  = iMACD(NULL,0,MACD_Fast,MACD_Slow,MACD_SigMA,0,MODE_SIGNAL,i);
   }
   
   
   for (i=limit; i>=0; i--)
   {  
       
  double std = Deviation*iStdDevOnArray(ExtMapBuffer3,0,StDevPeriod,0,StDevMethod,i);                 
              
          
      ExtMapBuffer1[i]=+std;
      ExtMapBuffer2[i]=-std;
       
     
   }  
  return(0);
 }
//+-------------------------------------------------------+