//+------------------------------------------------------------------+
//|                                       MACD+OsMA+AO+AC+T3_Ind.mq4 |
//|                    Copyright  2007 LeonSi, Chao$ Software Corp. |
//|                                             http://www.leonsi.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 LeonSi, Chao$ Software Corp."
#property link      "http://www.leonsi.ru"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 7
#property  indicator_color1 DarkSlateGray
#property  indicator_color2 LightSlateGray
#property  indicator_color3 Red
#property  indicator_color4 DarkGreen
#property  indicator_color5 SeaGreen
#property indicator_color6 MediumBlue
#property indicator_color7 DarkBlue

#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1
#property indicator_style3 2
#property indicator_width4 2
#property indicator_width7 2

//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
extern int Method=PRICE_CLOSE;
extern int     A_t3_period=9;
extern int     B_t3_period=24;
extern double  hot=0.7;
//---- indicator buffers
double     MACD[];
double     MACD_Signal[];
double     OsMA[];
double     ao[];
double     ac[];
double   t3fast[];
double   t3slow[];
//----
int shift;
double A_t3, A_t3_1, B_t3, B_t3_1;
double e1, e2, e3, e4, e5, e6, c1, c2, c3, c4;
double e1x, e2x, e3x, e4x, e5x, e6x;
double d1, d2, d3, d4, d5, d6;
double d1x, d2x, d3x, d4x, d5x, d6x;
double n, A_w1, A_w2, B_w1, B_w2, b2, b3;
double at;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   IndicatorShortName("OsMA+MACD+MACDSignal+AO+AC+T3Fast+T3SLOW");
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
 
   SetIndexLabel(0,"OsMA Main");
   SetIndexLabel(1,"MACD Main");
   SetIndexLabel(2,"MACD Signal");
   SetIndexLabel(3,"AO");
   SetIndexLabel(4,"AC");
//---- indicator buffers mapping
   SetIndexBuffer(0,OsMA);
   SetIndexBuffer(1,MACD);
   SetIndexBuffer(2,MACD_Signal);
   SetIndexBuffer(3,ao);
   SetIndexBuffer(4,ac);
   
   SetIndexLabel(5,"T3 Fast");
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,t3fast);
   SetIndexLabel(6,"T3 Slow");
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,t3slow);

   b2=hot*hot;
   b3=b2*hot;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+hot+b3);
   c4=(1+3*hot+b3+3*b2);
   n=A_t3_period;
if (n<1) n=1;
	n = 1 + 0.5*(n-1);
	A_w1 = 2 / (n + 1);
	A_w2 = 1 - A_w1;
	n=B_t3_period;
if (n<1) n=1;
	n = 1 + 0.5*(n-1);
	B_w1 = 2 / (n + 1);
	B_w2 = 1 - B_w1;
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for(int i=0; i<limit; i++)
      {
      OsMA[i]=iOsMA(NULL,0,FastEMA,SlowEMA,SignalSMA,Method,i);
      MACD[i]=iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,Method,MODE_MAIN,i);
      MACD_Signal[i]=iMACD(NULL,0,FastEMA,SlowEMA,SignalSMA,Method,MODE_SIGNAL,i);
      ao[i]=iAO(NULL,0,i)/3;
      ac[i]=iAC(NULL,0,i);
      }
   for(shift=Bars-A_t3_period-1; shift>=0; shift--)
   {
      d1=A_w1*Close[shift]+A_w2*d1x;
      d2=A_w1*d1+A_w2*d2x;
      d3=A_w1*d2+A_w2*d3x;
      d4=A_w1*d3+A_w2*d4x;
      d5=A_w1*d4+A_w2*d5x;
      d6=A_w1*d5+A_w2*d6x;
      A_t3=c1*d6+c2*d5+c3*d4+c4*d3;
      t3fast[shift]=A_t3-A_t3_1;
      A_t3_1 = A_t3;
      d1x=d1;	d2x=d2;	d3x=d3;	d4x=d4;	d5x=d5;	d6x=d6;
   }
   for(shift=Bars-B_t3_period-1; shift>=0; shift--)
   {
      e1=B_w1*Close[shift]+B_w2*e1x;
      e2=B_w1*e1+B_w2*e2x;
      e3=B_w1*e2+B_w2*e3x;
      e4=B_w1*e3+B_w2*e4x;
      e5=B_w1*e4+B_w2*e5x;
      e6=B_w1*e5+B_w2*e6x;
      B_t3=c1*e6+c2*e5+c3*e4+c4*e3;
      t3slow[shift]=B_t3-B_t3_1;
      B_t3_1=B_t3;
      e1x=e1;	e2x=e2;	e3x=e3;	e4x=e4;	e5x=e5;	e6x=e6;
   }
   if((t3slow[0]>0 && t3slow[1]<0) || (t3slow[0]<0 && t3slow[1]>0)) Comment(Symbol()," T3_Slow <> 0");
   return(0);
  }