//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern int FastLength      = 12;
extern int SlowLength      = 26;
extern int NormalizeLength = 50;
extern int Price           = PRICE_CLOSE;

double macd[];
double macdu[];
double macdd[];
double macdw[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,macdu); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,macdd); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,macd);
      SetIndexBuffer(3,macdw);
   IndicatorShortName("Normalized macd ("+FastLength+","+SlowLength+","+NormalizeLength+")");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      macdw[i] = (iMA(NULL,0,FastLength,0,MODE_EMA,Price,i)-iMA(NULL,0,SlowLength,0,MODE_EMA,Price,i));
        
        double min = macdw[ArrayMinimum(macdw,NormalizeLength,i)];
        double max = macdw[ArrayMaximum(macdw,NormalizeLength,i)];
           if (min!=max)
                macd[i] = 2.0*(macdw[i]-min)/(max-min)-1.0;
           else macd[i] = 0.0;
        
        //
        //
        //
        //
        //
        
        if (macd[i] > 0) { macdu[i] = macd[i]; macdd[i] = EMPTY_VALUE; }         
        if (macd[i] < 0) { macdd[i] = macd[i]; macdu[i] = EMPTY_VALUE; }         
   }         
   return(0);
}