//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    FastLength      = 12;
extern int    SlowLength      = 26;
extern int    NormalizeLength = 50;
extern int    Price           = PRICE_CLOSE;

double macd[];
double macdu[];
double macdd[];
double macdw[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,macdu); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,macdd); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,macd);
      SetIndexBuffer(3,macdw);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
               
   IndicatorShortName(timeFrameToString(timeFrame)+" Normalized macd ("+FastLength+","+SlowLength+","+NormalizeLength+")");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { macdu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         macdw[i] = (iMA(NULL,0,FastLength,0,MODE_EMA,Price,i)-iMA(NULL,0,SlowLength,0,MODE_EMA,Price,i));
        
        double min = macdw[ArrayMinimum(macdw,NormalizeLength,i)];
        double max = macdw[ArrayMaximum(macdw,NormalizeLength,i)];
            if (macdw[i]>0 && max!=0) macd[i] = macdw[i]/max;
            if (macdw[i]<0 && min!=0) macd[i] = macdw[i]/MathAbs(min);
        
        //
        //
        //
        //
        //
        
        if (macd[i] > 0) { macdu[i] = macd[i]; macdd[i] = EMPTY_VALUE; }         
        if (macd[i] < 0) { macdd[i] = macd[i]; macdu[i] = EMPTY_VALUE; }         
      }         
      return(0);
   }      

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         macd[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLength,SlowLength,NormalizeLength,Price,2,y);
         macdu[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLength,SlowLength,NormalizeLength,Price,0,y);
         macdd[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLength,SlowLength,NormalizeLength,Price,1,y);
   }   
   return(0);
   
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}