//+------------------------------------------------------------------+
//|                                                       s-MACD.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
//#property indicator_minimum 0
//#property indicator_maximum 100
#property indicator_buffers 6
#property indicator_color1 LightSeaGreen
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_color5 Green
#property indicator_color6 Red
//#property indicator_level1 80
//#property indicator_level2 50
//#property indicator_level3 20
//#property indicator_levelcolor Maroon
#property indicator_levelwidth 1
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT

//---- input parameters
extern int FastMA_Period=12;
extern int SlowMA_Period=26;
extern int SignalMA_Period=9;

int FastMA_Shift=0;
int FastMA_Method=1;
int FastMA_Price=0;
int FastMA_Timeframe=0;
int SlowMA_Shift=0;
int SlowMA_Method=1;
int SlowMA_Price=0;
int SlowMA_Timeframe=0;
int SignalMA_Shift=0;
int SignalMA_Method=0;


extern bool PlaySoundBuy = false;
extern bool PlaySoundSell = false;
extern int CheckBarForSound = 0;
extern string FileSoundBuy = "traingong";
extern string FileSoundSell = "traingong";

//---- buffers
double MainBuffer1[];
//double SignalBuffer1[];
double MainBuffer2[];
//double SignalBuffer2[];

double LineUpBuffer[];
double LineDnBuffer[];

//----
int draw_begin1=0;
int draw_begin2=0;

datetime BarSoundTime = 0;

string short_name;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- 2 additional buffers are used for counting.
   //IndicatorBuffers(6);
//---- indicator lines
//   if (ShowFastStoch)
           SetIndexStyle(0,DRAW_LINE,STYLE_DOT);
//      else SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0, MainBuffer1);
//   if (ShowFastStoch)
//           SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
//      else SetIndexStyle(1,DRAW_NONE);
//   SetIndexBuffer(1, SignalBuffer1);
//   if (ShowSlowStoch)
           SetIndexStyle(2,DRAW_LINE,STYLE_SOLID);
//      else SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2, MainBuffer2);
//   if (ShowSlowStoch)
//           SetIndexStyle(3,DRAW_LINE,STYLE_SOLID);
//      else SetIndexStyle(3,DRAW_NONE);
//   SetIndexBuffer(3, SignalBuffer2);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,233);
   SetIndexBuffer(4, LineUpBuffer);
//   SetIndexEmptyValue(4,indicator_minimum);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,234);
   SetIndexBuffer(5, LineDnBuffer);
//   SetIndexEmptyValue(5,indicator_minimum);
//---- name for DataWindow and indicator subwindow label
//   short_name="Stochastics-X("+K_fast+","+D_fast+","+S_fast+")&("+K_slow+","+D_slow+","+S_slow+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,"Signal");
//----
//   draw_begin1=K_slow+S_slow;
//   draw_begin2=draw_begin1+D_slow;
   SetIndexDrawBegin(0,SlowMA_Period);
   SetIndexDrawBegin(1,SlowMA_Period);
   
//----
//   SetIndexEmptyValue(2,indicator_minimum);
//   SetIndexEmptyValue(3,indicator_minimum);

//   if (ShowZone)
//   {
//      SetLevelStyle(STYLE_DOT ,1,DarkGreen);
//      SetLevelValue(0,ZoneHighPer);
//      SetLevelValue(1,ZoneLowPer);
//   }

   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
  
  
  
//+------------------------------------------------------------------+
//| Stochastic oscillator                                            |
//+------------------------------------------------------------------+
int start()
  {
  
   int    i;
   int    counted_bars=IndicatorCounted();
//----
   if(Bars<=draw_begin2) return(0);
//---- initial zero
   if(counted_bars<1)
     {
      for(i=1;i<=draw_begin1;i++) MainBuffer1[Bars-i]=0;
//      for(i=1;i<=draw_begin2;i++) SignalBuffer1[Bars-i]=0;
      for(i=1;i<=draw_begin1;i++) MainBuffer2[Bars-i]=0;
//      for(i=1;i<=draw_begin2;i++) SignalBuffer2[Bars-i]=0;
     }

//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;

   for(i=0; i<limit; i++)
   {
      MainBuffer1[i]=(iMA(Symbol(),FastMA_Timeframe,FastMA_Period,FastMA_Shift,FastMA_Method,FastMA_Price,i) - 
         iMA(Symbol(),SlowMA_Timeframe,SlowMA_Period,SlowMA_Shift,SlowMA_Method,SlowMA_Price,i))*10000;
   }

   for(i=0; i<limit-1; i++)
   {
   
      MainBuffer2[i]=iMAOnArray(MainBuffer1,Bars,SignalMA_Period,0,SignalMA_Method,i);
   }

//---- signal line is simple movimg average
   for(i=0; i<limit; i++)
   {
      //---- vertical line draw
      {
         if ((MainBuffer1[i+1]<=MainBuffer2[i+1]) 
              && (MainBuffer1[i]>MainBuffer2[i]) 
//              && (MainBuffer1[i+1]<ZoneLowPer) 
//              && (MainBuffer2[i+1]<ZoneLowPer)
            )
            {  
               LineUpBuffer[i] = MainBuffer2[i]-5;
            }
  //       else LineUpBuffer[i] = EMPTY;

         if ((MainBuffer1[i+1]>=MainBuffer2[i+1]) 
              && (MainBuffer1[i]<MainBuffer2[i]) 
//              && (MainBuffer1[i+1]>ZoneHighPer) 
//              && (MainBuffer2[i+1]>ZoneHighPer)
            )
            {  
               LineDnBuffer[i] = MainBuffer2[i]+5;
            }
  //       else LineDnBuffer[i] = EMPTY;
      }
   }
//----
 if (PlaySoundBuy && (LineUpBuffer[CheckBarForSound]>0))
  {
     if (BarSoundTime!=Time[CheckBarForSound])
        PlaySound(FileSoundBuy);
     BarSoundTime = Time[CheckBarForSound];
  }

  if (PlaySoundSell && (LineDnBuffer[CheckBarForSound]>0))
  {
     if (BarSoundTime!=Time[CheckBarForSound])
        PlaySound(FileSoundSell);
     BarSoundTime = Time[CheckBarForSound];
  }
   return(0);
  }
//+------------------------------------------------------------------+