
#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     Magenta
#property indicator_width1     3
#property indicator_color2     Aqua
#property indicator_width2     3
#property indicator_color3     Yellow
#property indicator_width3     3
#property indicator_color4     Silver 
#property indicator_width4     1
#property indicator_color5     Red
#property indicator_width5     1
#property indicator_color6     DodgerBlue
#property indicator_width6     2
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    T3FastPrice     = 0;
extern double T3FastPeriod    = 5;
extern double T3FastHot       = 0;
extern bool   T3FastOriginal  = false;
extern int    T3SlowPrice     = 0;
extern double T3SlowPeriod    = 34;
extern double T3SlowHot       = 0;
extern bool   T3SlowOriginal  = false;
extern double T3SignalPeriod  = 5;
extern double T3SignalHot     = 0;
extern bool   T3SignalOriginal= false;
extern int    OsmaX           = 2;
extern double level1          = 0.013;
extern double level2          = -0.013;

extern string _               = "alerts settings";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double osmaNu[];
double osmaDn[]; 
double osmaUp[]; 
double osma[];
double signal[];
double macd[];
double trend[];
double slope[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{

   IndicatorBuffers(8);
   SetIndexBuffer(0,osmaDn); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,osmaUp); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,osmaNu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,osma);
   SetIndexBuffer(4,signal);
   SetIndexBuffer(5,macd);
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,slope);
   SetLevelValue(0,0);
   SetLevelValue(1,level1);
   SetLevelValue(2,level2);

      //
      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);   

      //
      //
      //
      //
      //
   
  IndicatorShortName(timeFrameToString(timeFrame)+"  T3 osma macd("+DoubleToStr(T3FastPeriod,2)+","+DoubleToStr(T3SlowPeriod,2)+","+DoubleToStr(T3SignalPeriod,2)+")");
return(0);
}

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { osmaDn[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--) macd[i]   = iT3(iMA(NULL,0,1,0,MODE_EMA,T3FastPrice,i),T3FastPeriod,T3FastHot,T3FastOriginal,i,0) - 
                                              iT3(iMA(NULL,0,1,0,MODE_EMA,T3SlowPrice,i),T3SlowPeriod,T3SlowHot,T3SlowOriginal,i,1);
      for(    i=limit; i>=0; i--) signal[i] = iT3(macd[i],T3SignalPeriod,T3SignalHot,T3SignalOriginal,i,2);
      for(    i=limit; i>=0; i--) 
      {
             osma[i]   = (macd[i] - signal[i]) * OsmaX;
             osmaDn[i] = EMPTY_VALUE;
             osmaUp[i] = EMPTY_VALUE;
             osmaNu[i] = EMPTY_VALUE;
             trend[i]  = trend[i+1];
             slope[i]  = slope[i+1];
             
             //
             //
             //
             //
             //
             
             if (macd[i] > macd[i+1]) trend[i] =  1;
             if (macd[i] < macd[i+1]) trend[i] = -1;
             if (osma[i] > osma[i+1]) slope[i] =  1;
             if (osma[i] < osma[i+1]) slope[i] = -1;
                
             if (trend[i]== 1 && slope[i] == 1) osmaUp[i] = osma[i];
             if (trend[i]== 1 && slope[i] ==-1) osmaNu[i] = osma[i];
             if (trend[i]==-1 && slope[i] ==-1) osmaDn[i] = osma[i];
             if (trend[i]==-1 && slope[i] == 1) osmaNu[i] = osma[i];
               
      }
      manageAlerts();
      return(0);
      } 
      
      //
      //
      //
      //
      //
      
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
         for(i=limit; i>=0; i--)
         {
            int y = iBarShift(NULL,timeFrame,Time[i]);  
             osma[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3FastPrice,T3FastPeriod,T3FastHot,T3FastOriginal,T3SlowPrice,T3SlowPeriod,T3SlowHot,T3SlowOriginal,T3SignalPeriod,T3SignalHot,T3SignalOriginal,3,y);
             signal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3FastPrice,T3FastPeriod,T3FastHot,T3FastOriginal,T3SlowPrice,T3SlowPeriod,T3SlowHot,T3SlowOriginal,T3SignalPeriod,T3SignalHot,T3SignalOriginal,4,y);
             macd[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3FastPrice,T3FastPeriod,T3FastHot,T3FastOriginal,T3SlowPrice,T3SlowPeriod,T3SlowHot,T3SlowOriginal,T3SignalPeriod,T3SignalHot,T3SignalOriginal,5,y);
             trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3FastPrice,T3FastPeriod,T3FastHot,T3FastOriginal,T3SlowPrice,T3SlowPeriod,T3SlowHot,T3SlowOriginal,T3SignalPeriod,T3SignalHot,T3SignalOriginal,6,y);
             slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3FastPrice,T3FastPeriod,T3FastHot,T3FastOriginal,T3SlowPrice,T3SlowPeriod,T3SlowHot,T3SlowOriginal,T3SignalPeriod,T3SignalHot,T3SignalOriginal,7,y);
             osmaDn[i] = EMPTY_VALUE;
             osmaUp[i] = EMPTY_VALUE;
             osmaNu[i] = EMPTY_VALUE;
      
         }
         
         for(i=limit;i>=0;i--)
         {
             if (trend[i]== 1 && slope[i] == 1) osmaUp[i] = osma[i];
             if (trend[i]== 1 && slope[i] ==-1) osmaNu[i] = osma[i];
             if (trend[i]==-1 && slope[i] ==-1) osmaDn[i] = osma[i];
             if (trend[i]==-1 && slope[i] == 1) osmaNu[i] = osma[i];   
                               
   }
   
   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      
      if (slope[whichBar] != slope[whichBar+1] && trend[whichBar] != trend[whichBar+1])
      {
      if (slope[whichBar] == 1 && trend[whichBar] == 1) doAlert(whichBar,"buy");
      if (slope[whichBar] ==-1 && trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
     
    } 
            
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," osma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," osma"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][18];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}